<%@ page language="c#" inherits="CardioLog.CLPage.ADChooserNew, CardioLog_deploy" %>

<%@ Register TagPrefix="popup" TagName="top" Src="/CardioLog/Includes/PopupTop.ascx" %>
<%@ Register TagPrefix="popup" TagName="bottom" Src="/CardioLog/Includes/PopupBottom.ascx" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML>
	<HEAD>
		<title>addToManage</title>
		<LINK rel="stylesheet" type="text/css" href="/CardioLog/Styles/2010_general.css"></LINK>
		<LINK rel="stylesheet" type="text/css" href="/CardioLog/Styles/2010_popup_selectscrollpanel.css"></LINK>
			
		<script>
		    var popupArguments;
		    
			function setPopupArguments(arguments) {
			    popupArguments = arguments.popupArguments[0];
			    document.Status = popupArguments.self.Status || popupArguments.self.document.Status;
			    document.Ajax = popupArguments.self.Ajax || popupArguments.self.document.Ajax;
			    
				document.all["popup_title"].innerText = popupArguments.title;
				
				if (popupArguments.selectedGroup) {
					var ids = popupArguments.selectedGroup.value.split(",");
					var names = popupArguments.selectedGroup.innerText.split(",");
					var groups = new Array();
					for (var i=0;i<ids.length;i++) {
						var shouldDiscard = (ids[i].match(/^\!/)) ? true : false;
						ids[i] = ids[i].replace(/^\!/, "");
						if (ids[i] != "") groups[groups.length] = {value:ids[i], text:names[i].replace(/^[ ]*/, ""), discard:shouldDiscard};
					}
					resetSelected(groups);
				}
				if (popupArguments.values) {
					document.all["searchTermInput"].value = popupArguments.value;
					resetResults(popupArguments.values);
				}
				if (popupArguments.value) {
					document.all["searchTermInput"].value = popupArguments.value;
					document.all["searchTermInput"].select();
				}
				if (popupArguments.autoSearch) {
				    doSearch();
				}
				
				if (popupArguments.single) {
					document.all["selectedTR"].style.display = "none";
					document.all["buttonsTR"].style.display = "none";
					document.all["searchResultsInput"].size = 16;
					document.all["searchResultsInput"].multiple = false;
					document.all["searchaddButton"].style.display = "none";
				}
				document.all["searchTermInput"].focus();
			}
			
			function handleResults(status) {
				if (status.errorCode != 0) {
					showError("Error - "+status.reason);
				} else {
					var results = status.ResponseXml.selectNodes(".//result");
					var arr = new Array();
					for (var i=0;i<results.length;i++) {
						if (getType() == 2)
							arr[arr.length] = {value:results[i].getAttribute("id"), text:results[i].text, type:results[i].getAttribute("type")};
						else
							arr[arr.length] = {value:results[i].getAttribute("id"), text:results[i].text};
					}
					resetResults(arr);
				}
			}

			function getType() {
				switch (popupArguments.type) {
					case "G": // group
						return 0;
						break;
					case "U": // user
						return 1;
						break;
					case "M": // mail
						return 3;
					default: // all
						return 2;
				}
			}
						
		    function showPleaseWait() {
				for (var i=document.all["searchResultsInput"].children.length-1;i>=0;i--) document.all["searchResultsInput"].children[i].removeNode(true);
		        var option = document.getElementById("searchResultsInput").appendChild(document.createElement("option"));
		        option.innerText = "<%=CardioLog.API.Localization.getText("$Loading$")%>...";
		        option.value = -1;
		        option = null;
		    }
			function doSearch() {
			    showPleaseWait();
				try {
					var term = document.all["searchTermInput"].value.replace(/^[ ]*/, "").replace(/[ ]*$/,"");
					if (term == "") return;
					document.all["searchTermInput"].value = term;
					if (document.Ajax != null) {
						document.Ajax.Request("GET", "data/QueryAD.aspx", "term="+escape(term)+"&type="+getType()+"&rid="+Math.random()*100000, true, false, handleResults);
					} else showError("<%=CardioLog.API.Localization.getText("$Could not connect to AD$")%>");
				} catch (e) {
					showError(e.description);
				}
			}
			
			function handleKey() {
				if (event.keyCode == 13 || (event.keyCode == 75 && event.ctrlKey)) {
					event.returnValue = false;
					event.keyCode = 0;
					doSearch();
					return false;
				}
			}
			
			function showError(message) {
				resetResults(new Array({value:-1, text:message}));
				document.all["searchResultsInput"].className = "largeInputSelectError";
			}
			function resetResults(values) {
				for (var i=document.all["searchResultsInput"].children.length-1;i>=0;i--) document.all["searchResultsInput"].children[i].removeNode(true);
				if (values) {
					for (var i=0;i<values.length;i++) {
						var optionTag = null;
						if (getType() == 2) {
							optionTag = "<option value='"+values[i].value+";"+ values[i].type +"'>";
						} else {
							optionTag = "<option value='"+values[i].value+"'>";
						}
						var option = document.createElement(optionTag);
						option.innerText = values[i].text;
						document.all["searchResultsInput"].appendChild(option);
						option = null;
					}
				}
			}
			function resetSelected(values) {
				for (var i=document.all["selectedInput"].children.length-1;i>=0;i--) document.all["selectedInput"].children[i].removeNode(true);
				if (values) {
					for (var i=0;i<values.length;i++) {
						var id = (values[i].discard) ? "!"+values[i].value : values[i].value;
						var text = values[i].text;
						var option = document.createElement("<option value='"+id+"'>");
						if (values[i].discard) option.style.color = "red";
						option.innerText = text;
						document.all["selectedInput"].appendChild(option);
						option = null;
					}
				}
			}
			function toggleDiscard(discard, obj) {
				obj.text = (discard) ? "!"+obj.text : obj.text.replace(/^\!/, "");
				obj.id = (discard) ? "!"+obj.id : obj.id.replace(/^\!/, "");
				return obj;
			}
			
			function toggleNot() {
				if (document.all["selectedInput"].selectedIndex != -1) {
					for (var i=0;i<document.all["selectedInput"].options.length;i++) {
						if (!document.all["selectedInput"].options[i].selected) continue;
						var obj = {text:document.all["selectedInput"].options[i].innerText, id:document.all["selectedInput"].options[i].value };
						var shouldDiscard = !obj.text.match(/^\!/);
						obj = toggleDiscard(shouldDiscard, obj);
						document.all["selectedInput"].options[i].innerText = obj.text;
						document.all["selectedInput"].options[i].value = obj.id;
						document.all["selectedInput"].options[i].style.color = (shouldDiscard) ? "red" : "";
					}
				}
			}
			
			function addToSelected(select) {
                if ("<%=CardioLog.API.PII.ConcealPII()%>" == "False") {
					if (popupArguments.single) {
						save();
						return;
					}
					function addOption(value, text) {
						for (var i=0;i<document.all["selectedInput"].options.length;i++) {
							if (document.all["selectedInput"].options[i].value == value) {
								return;
							}
						}
						var option = document.createElement("option");
						option.value = value;
						option.innerText = text;
						document.all["selectedInput"].appendChild(option);
						option = null;
					}
					if (select) {
						if (select.selectedIndex < 0) return;
						addOption(select.options[select.selectedIndex].value, select.options[select.selectedIndex].innerText);
					} else {
					    // When there is no AD integration - allow to filter by user name
						if (document.all["searchResultsInput"].options.length == 0 && document.all["searchTermInput"].value != "") {
						    addOption(document.all["searchTermInput"].value + ";user", document.all["searchTermInput"].value);
						} else {
						    for (var i=0;i<document.all["searchResultsInput"].options.length;i++) {
							    if (document.all["searchResultsInput"].options[i].selected) {
								    addOption(document.all["searchResultsInput"].options[i].value, document.all["searchResultsInput"].options[i].innerText);
							    }
						    }
						}
					}
					document.all["searchResultsInput"].selectedIndex = -1;
                } else {
                    return;
                }
			}
			
			function removeFromSelected(select) {
				function removeOption(value) {
					var pos = -1;
					for (var i=0;i<document.all["selectedInput"].options.length;i++) {
						if (document.all["selectedInput"].options[i].value == value) {
							pos = i;
							break;
						}
					}
					for (var i=pos;i<document.all["selectedInput"].options.length-1;i++) {
						document.all["selectedInput"].options[i].value = document.all["selectedInput"].options[i+1].value;
						document.all["selectedInput"].options[i].innerText = document.all["selectedInput"].options[i+1].innerText;
					}
					document.all["selectedInput"].options.length -= 1;
				}
				if (select) {
					if (select.selectedIndex < 0) return;
					removeOption(select.options[select.selectedIndex].value);
				} else {
					for (var i=document.all["selectedInput"].options.length-1;i>=0;i--) {
						if (document.all["selectedInput"].options[i].selected) removeOption(document.all["selectedInput"].options[i].value);
					}
				}
				document.all["selectedInput"].selectedIndex = -1;
			}
			
			function save() {
				if (popupArguments.single) {
					if (document.all["searchResultsInput"].selectedIndex < 0) {
						return;
					}
					var type = null;
					var value = document.all["searchResultsInput"].options[document.all["searchResultsInput"].selectedIndex].value;
					if (getType() == 2){
						var arr = value.split(";")
						value = arr[0];
						type = arr[1];
					}
					popupArguments.callback(value, document.all["searchResultsInput"].options[document.all["searchResultsInput"].selectedIndex].innerText, type);
				} else {
					var groups = "";
					var ids = "";
					
					for (var i=0;i<document.all["selectedInput"].options.length;i++) {
						
						groups += document.all["selectedInput"].options[i].innerText+", ";
						ids += document.all["selectedInput"].options[i].value+",";
					}
					groups = groups.replace(/, $/, "");
					ids = ids.replace(/,$/, "");
					popupArguments.callback(groups, ids);
				}
			}			
						
			function apply() {
			save();
			try {
			        parent.hideSecondaryPopup();
			    } catch (e) {
			        parent.hidePopup();
		        }    
			}
			
			function cancel(){
			    try {
			        parent.hideSecondaryPopup();
			    } catch (e) {
			        parent.hidePopup();
		        }
			}
			
		</script>
	</HEAD>
	<BODY scroll="no" class="popupBODY">
	    <popup:top Title="$Select Users and Groups$" runat="server" id="top"/>
		<TABLE cellpadding="0" cellspacing="0" border="0" width="100%" style="height:364px" class="popup_Border">
			<TR>
				<TD>
					<TABLE cellpadding="0" cellspacing="0" border="0" width="100%" class="boxHeader" style="CURSOR:default">
						<TR>
							<TD class="boxHeaderText" id="title">:</TD>
						</TR>
					</TABLE>
				</TD>
			</TR>
			<TR>
				<TD class="2010_popup_boxContentWindow" valign="top" width="100%" height="100%">
					<TABLE cellpadding="" cellspacing="0" border="0" width="100%" height="100%">
						<tr>
							<td class="2010_popup_selectscrollpanelButtonSubtab">
								<table border="0" cellspacing="0" cellpadding="0" width="100%" style="padding-top:3px; padding-bottom:3px; table-layout:fixed;">
									<tr style="height:40px;">
									    <td class="2010_popup_largeTextB" style="padding-left:10px;width:50px"><%=CardioLog.API.Localization.getText("$Name$")%> </td>
									    <td nowrap="true" valign="middle" width="250px" style="padding-right:5px;">						
										    <input type="hidden" id="searchTermLabel"/>
										    <input type="text" onkeydown="handleKey()" id="searchTermInput" class="inputText" style="WIDTH:100%">
										</td>
										 <td>
	    							        <input type="button" id="searchButton" style="background-image:url(/CardioLog/images/2010/searchBtn.gif); width:63px; height:17px; border:none" onclick="doSearch()">
                                            <%if (!CardioLog.API.PII.ConcealPII())
                                              { %>
		    						        <input type="button" id="searchaddButton" style="background-image:url(/CardioLog/images/2010/AddSmallBtn.gif); width:43px; height:17px; border:none" onclick="addToSelected()">
                                            <%} %>
		    						    </td>
									</tr>									
									<tr>
									    <td class="2010_popup_black_horizontalSeparator" colspan="3"><img src="/CardioLog/images/blank.gif" />
									    </td>
								    </tr>
									<tr>
									    <td colspan="3" height="100%" class="2010_popup_largeinputSelect">
											<span class="2010_popup_largeTextB "><%=CardioLog.API.Localization.getText("$Search Results$")%>:</span><br />
											<select id="searchResultsInput" ondblclick='addToSelected(this);' size="6" multiple style="WIDTH:350px" class="largeInputSelect"></select>
										</td>
									</tr>
									<tr id="buttonsTR" class="2010_popup_buttonPane" style="background-color:White; ">
									    <td colspan="3" align="left">
									        <button style="width:103px; height:17px; border:none;" onclick="addToSelected();" type="button"><img src="/CardioLog/images/2010/AddBtn.gif"></button>
									        <button id="notButton" style="width:103px; height:17px; border:none;" class="2010_popup_inputButton" onclick="toggleNot();"><img src="/CardioLog/images/2010/ExcludeBtn.gif"></button>
									    </td>
									</tr>									
									<tr>
									    <td class="2010_popup_black_horizontalSeparator" colspan="3"><img src="/CardioLog/images/blank.gif" />
									    </td>
								    </tr>
									<tr id="selectedTR" height="100%">
									    <td colspan="3" class="2010_popup_largeinputSelected">
											<span class="2010_popup_largeTextB " id="selectedLabel"></span><br>
											<select id="selectedInput" ondblclick='removeFromSelected(this);' size="6" multiple style="WIDTH:350px" class="largeInputSelect"></select>
											<input type="button" id="rmvBtn" style="background-image:url(/CardioLog/images/2010/RemoveBtn.gif); width:103px; height:17px; border:none; margin-left:10px;" onclick="removeFromSelected()"/>
										</td>
									</tr>
						            <tr>
							            <td align="center">
								            <table cellpadding="0" cellspacing="0" border="0" style="PADDING-RIGHT:5px">
									            <tr>
										            <td class="error" colspan="2" id="errorTD"></td>
									            </tr>
								            </table>
							            </td>
						            </tr>
								</table>
							</td>
						</tr>
					</TABLE>
				</TD>
			</TR>									
			<tr>
			    <td class="2010_popup_black_horizontalSeparator"><img src="/CardioLog/images/blank.gif" /></td>
		    </tr>
		</TABLE>
	  <popup:bottom ButtonOK="True" ButtonCancel="True" runat="server" ID="bottom"/>		
	</BODY>
</HTML>
