<%@ Page Language="JScript" %>
<% Response.ContentType = "text/javascript"; %>
try {
	element.changePath = function() {
		var newPath = prompt("Location of alternative collector:", __Page.GetEventCollectorUrl());
		if (newPath != null && newPath != "") {
			__Page.SetEventCollectorUrl(newPath);
		} else {
			__Page.DeleteEventCollectorUrl();
		}
		return __Page.GetEventCollectorUrl();
	}

	var cookiesc = new Array();
	cookiesc["lastPage"] = "lp";
	cookiesc["pagesSinceLastSearch"] = "psls";
	cookiesc["LastSearchTerm"] = "lst";
	cookiesc["LastSearchedArea"] = "lsa";
	cookiesc["LastSearchEventId"] = "lsei";
	cookiesc["LastSearchResultsCount"] = "lsrc";
	cookiesc["session"] = "s";
	cookiesc["LastEventId"] = "lei";
	cookiesc["ReferrerReason"] = "rr";
	cookiesc["Referrer"] = "r";
	cookiesc["agentCookies"] = "ac";
	cookiesc["AlternativeEventCollector"] = "aec";
	cookiesc["LastDuration"] = "ld";
	cookiesc["LastEventToSend"] = "le";
	cookiesc["LastEventsToSend"] = "les";
	
	var __eTypes = {Page:0, Search:3};
	var __eEvents = {Visit:{id:0, name:"Visit"},
					Leave:{id:1, name:"Leave"},
					Search:{id:2, name:"Search"},
					External:{id:10, name:"External"},
					Unknown:{id:-1, name:"Unknown"}};

	var __Page = {
		agent:"Unknown",
		entityType: null,
		eventType: null,
		readyState:null,
		document:null,
		events: {},
		//timestamp: new Date(),
		timestamp: getServerDate(),
		firstPageInSession: false,
		Search: {readyState:null,
				 Input:null,
				 Results:new Array(),
				 NumberOfTotalResults:0},
		init: function() {
			__trace("__Page.init");
			this.document = element.document;
			this.url = this.document.location.href;
			this.readyState = this.shouldContinue();
			
			function keydown(e) {
				e = (e) ? e : event;
				if ((typeof(element["EnableConsole"]) == "undefined" || element.EnableConsole) && (e.ctrlKey) && e.keyCode == 123) __Page.showConsole();
				else if ((typeof(element["EnableConsole"]) == "undefined" || element.EnableConsole) && (typeof(element["EnableAltKey"]) == "undefined" || element.EnableAltKey) && e.altKey && e.keyCode == 123) __Page.showConsole();
			}
			function beforeunload(e) {
				e = (e) ? e : event;
				
				//var endDate = new Date();
				var endDate = getServerDate();
//				if ((endDate-__Page.timestamp) > element.MaxDuration && __EventHandler.lastEventId) return;
				var leaveEvent = __EventHandler.New(__eEvents.Leave);
				leaveEvent.X = ((endDate-__Page.timestamp) > element.MaxDuration) ? element.MaxDuration : Math.abs(endDate-__Page.timestamp);
				leaveEvent.Y = __EventHandler.lastEventId;
				leaveEvent.u = __Referrer.stripcampaignparams(leaveEvent.u);
   				//leaveEvent.timestamp = dateToString(new Date());
   				leaveEvent.timestamp = dateToString(getServerDate());
   				__Page.sendEvent(leaveEvent, false, true);
//				__Page.CookieHandler.Save("LastDuration", escape(leaveEvent.ToString()), 1000);
			}
			if (element.BrowserType == "ie") {
				element.document.attachEvent("onkeydown", keydown);
				window.attachEvent("onbeforeunload", beforeunload);
			} else {
				element.document.addEventListener("keydown", keydown, false);
				window.addEventListener("beforeunload", beforeunload, false);
			}

			function toEvent(eventString) {
				__trace("toEvent: "+eventString);
				if (eventString != null) {
					var ent, u, t, X, Y, et;
					var timestamp = "";
					var RI = "";
					eventString = unescape(eventString).replace("<event><![CDATA[", "").replace("]]></event>", "");
					var values = eventString.split("&");
					for (var i=0;i<values.length;i++) {
						var pair = values[i].split("=");
						switch (pair[0]) {
							case "ent":
								ent = pair[1];
								break;
							case "u":
								var url = new Array();
								for (var p=1;p<pair.length;p++) url.push(unescape(pair[p]));
								u = url.join("=");
								break;
							case "t":
								t = pair[1];
								break;
							case "X":
								X = pair[1];
								break;
							case "Y":
								Y = pair[1];
								break;
							case "et":
								et = pair[1];
								break;
							case "timestamp":
								timestamp = pair[1];
								break;
							case "RI":
								RI = pair[1];
								break;
						}
					}
					var event = new __Event(et, u, X, Y);
					if (timestamp != "") event.timestamp = timestamp;
					if (RI != "") event.RI = RI;
					return event;
				}
				return null;
			}

			var durationEvent = toEvent(__Page.CookieHandler.Read("LastDuration"));
			__trace("durationEvent: "+((durationEvent != null) ? durationEvent.ToString() : null));
			if (durationEvent != null) {
				__Page.sendEvent(durationEvent, false, true);
				__Page.CookieHandler.Delete("LastDuration");
			}

			// 28/12/2008: handle multiple clicks on external links (currently stores the last one only)
			var eventsInQueue = __Page.CookieHandler.Read("LastEventsToSend");
			__trace("eventsInQueue: "+eventsInQueue);
			if (eventsInQueue != null) {
				var events = unescape(eventsInQueue).match(/<event><!\[CDATA\[[^>]*\]\]><\/event>/g);
				var event = null;
				if (events != null) {
					for (var e=0;e<events.length;e++) {
						if (event == null) event = toEvent(events[e]);
						else event.addEvent(toEvent(events[e]));
					}
				}
				if (event != null) {
					__trace("sendEvent: "+event.ToString());
					__Page.sendEvent(event, false, true);
					__Page.CookieHandler.Delete("LastEventsToSend");
				}
			}			
			//var lastEventToSend = toEvent(__Page.CookieHandler.Read("LastEventToSend"));
			//if (lastEventToSend != null) {
			//	__Page.sendEvent(lastEventToSend, false, true);
			//    __Page.CookieHandler.Delete("LastEventToSend");
			//}

			if (this.readyState != "ready" && this.readyState != "duplicate") return;
			if (typeof(this.customInit) != "undefined") this.customInit();
		},
		shouldContinue: function() {
			if (typeof(this.customShouldContinue) != "undefined") return this.customShouldContinue();
			return "ready";
		},
		shouldIncludeEvent: function(name) {
			if ((typeof(element["Event_"+name]) == "undefined" && !eval(element.Greedy)) || element["Event_"+name] == "false") return false;
			else return true;
		},
		setReferrer:function(eventType, value) {
			if (!eventType) {
				this.CookieHandler.Delete("ReferrerReason");
				this.CookieHandler.Delete("Referrer");
			} else {
				this.CookieHandler.Save("ReferrerReason", eventType);
				this.CookieHandler.Save("Referrer", value);
			}
		},
		SetReferrer:function(eventType, value) {
			this.setReferrer(eventType, value);
		},
		AddCustomEvent:function(eventName, eventId) {
			__eEvents[eventName] = {name:eventName, id:eventId};
		},
		GetEvent:function(eventName, id, param1, param2, RI) {
			var eventId = null;
			for (var i in __eEvents) {
				if (__eEvents[i].name == eventName) {
					eventId = __eEvents[i];
					break;
				}
			}
			if (eventId == null) throw {description:"Unrecognized event type ("+eventName+")"};
			var event = new __Event(eventId, id, param1, param2);
			if (typeof(RI) != "undefined") event.RI = RI;
			return event;
		},
		SendEvent:function(eventName, id, param1, param2, eventCallback) {
		    // For external use
			// Todo: use GetEvent instead of doing the same logic here again
			var eventId = null;
			for (var i in __eEvents) {
				if (__eEvents[i].name == eventName) {
					eventId = __eEvents[i];
					break;
				}
			}

			if (eventId == null) throw {description:"Unrecognized event type ("+eventName+")"};
			var event = new __Event(eventId, id, param1, param2);
			if (param1 != null) event.referrer = {"ignoreref":typeof(param1) == "undefined" || param1 == null, ToString:function() { return param1; }};
			else if (typeof(event.referrer) == "undefined") event.referrer = {"ignoreref":true, ToString:function() { return ""; }};

//			if (eventName == "Visit" && typeof(id) != "undefined" && id) event.u = id;
			if (eventName == "Search") event.storeEventAsSearch = true;
			this.sendEvent(event, eventCallback, (eventCallback) ? false : true, true);
			if (!eventCallback) return true;
		},
		sendEvent:function(event, eventCallback, ignoreResponse, force) {
			if (event == null) {
				__trace("event is null. do not send anything");
				__Status.print('event is null. do not send anything');
				return;
			}
			if (this.readyState == "duplicate" && this.CookieHandler.Read("ignoreDuplicates") == null && !force) {
				__trace("should not send event. ignore duplicates");
				return;
			}
			if ((typeof(element["Event_"+event.et.name]) == "undefined" && !eval(element.Greedy)) || element["Event_"+event.et.name] == "false") {
				__trace("should not sent event. event is not supported");
				return;
			}
 			var sessionId = this.getClientSession();
 			__trace("sessionId: "+sessionId);

			if (event.et.id == __eEvents.Visit.id) {
				// if campaign tracking was specifically defined in URL
				if (this.document.location.search.match(/\_\_Referrer\=/i)) {
					event.X =  this.document.location.search.replace(/^.*\_\_Referrer\=([^\&]*).*$/i, "$1");
					event.u = event.u.replace(/(\?|\&)__Referrer=[^\&]*/, "");
				} else if (this.CookieHandler.Read("Referrer") != null) {
					event.X =  this.CookieHandler.Read("ReferrerReason");
					event.Y = this.CookieHandler.Read("Referrer");
					this.setReferrer();
				} else {
					event.X = ((this.firstPageInSession) ? "First In Session" : "")+((event.referrer.ignoreref || typeof(element["GetReferrerData"]) == "undefined" || !element.GetReferrerData) ? "" : "|"+event.referrer.ToString());
					if (typeof(event.u) == "undefined" || event.u == "" || event.u == null) event.u = document.location.href; //event.referrer.url;
				}

                // handle RI only in case of relevant event[s] (e.g. View)
				if (this.CookieHandler.Read("LastEventId") != null) {
					event.RI = this.CookieHandler.Read("LastEventId");
					this.CookieHandler.Delete("LastEventId");
				}
			}

			// TODO: take care of cases the flatEvent is longer than 2000 characters. Create chunks and call AJAX.Request per event
 			var flatEvent = event.ToString();
 			__trace("event: "+flatEvent);

			var collectorUrl = (this.CookieHandler.Read("AlternativeEventCollector") != null && this.CookieHandler.Read("AlternativeEventCollector") != "") ? this.CookieHandler.Read("AlternativeEventCollector") : element.EventCollectorPath;

			// Get browser type
			var browser = navigator.userAgent.toLowerCase();

 			var parameters = "browserType="+browser+"&sessionId="+sessionId+"&u="+collectorUrl+"&events=<events>"+encodeURIComponent(flatEvent)+"</events>";
 			if (element.SupportAnonymousUsers) parameters += "&un="+((typeof(__Page.username) == "undefined") ? "Anonymous" : __Page.username);

			if (element.Param3ElementName) parameters += "&P3="+((typeof(__Page.param3) == "undefined") ? "" : __Page.param3);
            
			var storeEventAsSearch = (event.storeEventAsSearch) ? true : false;
			var numberOfSearchResults = (event.et == __eEvents.Search) ? event.Y : -1;
			var positionOfFirstResult = (event.et == __eEvents.Search) ? event.Z : -1;

			function callback(status) {
				__trace("event sent. status: "+status.errorCode);
				if (status.errorCode != 0) __Page.handleFailedEvents(parameters);
				var lastEventId = null;
				
				if (typeof(status.eventId) != "undefined") {
				    lastEventId = status.eventId;
				} else if (status.ResponseXml && status.ResponseXml.selectSingleNode(".//event")) {
				    lastEventId = status.ResponseXml.selectSingleNode(".//event").getAttribute("id");
				}
				if (lastEventId != null) __EventHandler.SetLastEventId(lastEventId, storeEventAsSearch);

			    if (positionOfFirstResult > -1) __Page.CookieHandler.Save("LastSearchResultsCount", positionOfFirstResult, parseInt(element.SearchPeriod, 10)/1440);
				if (eventCallback && !ignoreResponse) eventCallback(status);
				if (status.errorCode != 0) __Status.print("Error registering event - "+status.reason, "statusbar");
				else __Status.print("Event #"+__EventHandler.lastEventId+" registered successfully.", "statusbar");
			}
			__Status.print(event.ToString(true));

			// TODO: loop through events (to handle 2048 limitation)
			__trace("sending event: "+event.ToString()+" to "+element.TunnelPath+" with parameters: "+parameters);
			__Ajax.Request("POST", element.TunnelPath, parameters, true, false, callback, ignoreResponse);
		},
		getClientSession: function() {
		    var sessionid = this.CookieHandler.Read("session");
			if (sessionid == null || isNaN(parseFloat(sessionid))) {
				sessionid = Math.round(Math.random()*1000000000)+"."+Math.round(Math.random()*1000000000);
				this.firstPageInSession = true;
				this.CookieHandler.Save("session", sessionid);
			}
			return sessionid;
		},
		GetEventCollectorUrl: function() {
			if (__Page.CookieHandler.Read("AlternativeEventCollector") != null && __Page.CookieHandler.Read("AlternativeEventCollector") != "") return __Page.CookieHandler.Read("AlternativeEventCollector");
			else return element.EventCollectorPath;
		},
		SetEventCollectorUrl: function(url) {
			__Page.CookieHandler.Save("AlternativeEventCollector", url);
		},
		DeleteEventCollectorUrl: function() {
			__Page.CookieHandler.Delete("AlternativeEventCollector");
		},
		CookieHandler: {
			SaveCookie:function(name, value, days) {
				var oldCookies = document.cookie;
				name = (cookiesc[name]) ? cookiesc[name] : name;
				name = "__"+name;
				if (days) {
					//var date = new Date();
					var date = getServerDate();
					date.setTime(date.getTime()+(days*24*60*60*1000));
					var expires = "; expires="+date.toGMTString()
				} else expires = "";
				document.cookie = name+"="+value+expires+"; path=/"
				var newCookies = document.cookie;
				if (oldCookies.match(/__lsei/) && !newCookies.match(/__lsei/)) {
					prompt("", 'during this save it was deleted:\n'+name+','+value+'\n'+oldCookies.length+':'+newCookies.length+'\n'+oldCookies+'\n'+newCookies);
				}
			},
			ReadCookie:function(name) {
				name = (cookiesc[name]) ? cookiesc[name] : name;
				name = "__"+name;
				name += "=";
				var cookieArr = document.cookie.split(';');
				for (var i=0;i<cookieArr.length;i++) {
					var c = cookieArr[i];
					while (c.substring(0,1) == ' ') c = c.substring(1, c.length);
					if (c.indexOf(name) == 0) return c.substring(name.length, c.length);
				}
				return null
			},
			DeleteCookie:function(name) {
				this.Save(name, "", -1);
			},
			Read:function(name) {
				var agentCookies = (this.ReadCookie("agentCookies") == null) ? new Array() : this.ReadCookie("agentCookies").split("*");
				var cookieFound = false;
				for (var i=0;i<agentCookies.length;i++) {
					if (agentCookies[i].split("=")[0] == name) {
						return agentCookies[i].split("=")[1];
					}
				}
				return this.ReadCookie(name);
			},
			Save:function(name, value, days) {
				if (days) this.SaveCookie(name, value, days);
				else {
					var agentCookies = (this.ReadCookie("agentCookies") == null) ? new Array() : this.ReadCookie("agentCookies").split("*");
					var cookieFound = false;
					for (var i=0;i<agentCookies.length;i++) {
						if (agentCookies[i].split("=")[0] == name) {
							agentCookies[i] = name+"="+value;
							cookieFound = true;
							break;
						}
					}
					if (!cookieFound) agentCookies[agentCookies.length] = name+"="+value;
					this.SaveCookie("agentCookies", agentCookies.join("*"));
				}
			},
			Delete:function(name) {
				var agentCookies = (this.ReadCookie("agentCookies") == null) ? new Array() : this.ReadCookie("agentCookies").split("*");
				var cookiePosition = -1;
				for (var i=0;i<agentCookies.length;i++) {
					if (agentCookies[i].split("=")[0] == name) {
						cookiePosition = i;
						break;
					}
				}
				if (cookiePosition >= 0) {
					for (var i=cookiePosition;i<agentCookies.length-1;i++) agentCookies[i] = agentCookies[i+1];
					agentCookies.length -= 1;
					this.SaveCookie("agentCookies", agentCookies.join("*"));
				} else this.DeleteCookie(name);
			}
		},
		parameters: null,
		getParameter: function(name) {
			// TODO: get parameters from location.search
			if (this.parameters == null) {
				// split document.location.search into array
			}
			//return correct parameter (or all if name is false)
		},
		showConsole: function() {
			try {
				if (document.getElementById("intlock_debugWindow") != null) {
					document.getElementById("intlock_debugWindow").style.display = document.getElementById("intlock_debugWindow").style.display == "none" ? "" : "none";
				} else {
					document.consoleObject = {self:self, GetEventCollector:this.GetEventCollectorUrl, currentMessage:__Status.currentMessage, output:__Status.output, page:__Page, element:element, lastEventId:__EventHandler.lastEventId};
					// debug window on different domain, open as layer
					var script = document.createElement("script");
					script.src = element.AgentDirectory+"/debugWindow.js";
					document.body.appendChild(script);
				}
				//this.console = window.showModelessDialog(element.AgentDirectory+"/debugWindowCont.aspx", {self:self, GetEventCollector:this.GetEventCollectorUrl, currentMessage:__Status.currentMessage, output:__Status.output, page:__Page, element:element, lastEventId:__EventHandler.lastEventId}, "dialogHeight:308px; dialogWidth:450px; status:no; help:no;");
			} catch (e) {
				alert("Disable popup blocker for this domain.");
			}
		},
		handleFailedEvents: function(parameters) {
			if (!this.failedEvents) this.failedEvents = new Array();
			//this.failedEvents[this.failedEvents.length] = {timestamp:new Date(), parameters:parameters};
			this.failedEvents[this.failedEvents.length] = {timestamp:getServerDate(), parameters:parameters};
		},
		attachEvent: function(event, handler, source) {
			if(!this.__events) this.__events = {}
			if(!this.__events[event]) this.__events[event] = []
			this.__events[event][this.__events[event].length] = {fp:handler,s:source}
		},
		detachEvent: function(event, handler, source) {
			if(this.__events && this.__events[event]){
				var o = this.__events[event]
				for(var i=0; i<o.length; i++){
					if (o[i]) {
						if((o[i].s && o[i].s==source) || !o[i].s){
							try {
								if(o[i].fp.toString() == handler.toString()) {
									delete o[i];
								}
							} catch (e) {
							}
						}
					}
				}
			}
		},
		fireEvent: function(event) {
			this.pageEvents[this.pageEvents.length] = event;
			var a = arguments
			if(this.__events && this.__events[event]){
				var o = this.__events[event]
				for(var i=0; i<o.length; i++){
					if(o[i]){
						if(o[i].s){
							o[i].s.__eventhandler = o[i].fp
							o[i].s.__eventhandler(a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9],a[10])
							delete o[i].s.__eventhandler
						}
						else{
							this.__eventhandler = o[i].fp
							this.__eventhandler(a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9],a[10])
							delete this.__eventhandler
						}
					}
				}
			}
			if(typeof(this[event])=="function"){
				window.setTimeout(function() { this[event](a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9],a[10]) }, 1);
			}
		},
		pageEvents: new Array(),
		wasFired: function(eventName) {
			for (var i=0;i<this.pageEvents.length;i++) if (this.pageEvents[i] == eventName) return true;
			return false;
		},
		HelpletReadyState: null,
		registerHelplet: function(eventName, callback) {
			if (this.wasFired(eventName)) callback();
			else __Page.attachEvent(eventName, function() { callback(); });
		},
		GetParameter: function(paramName) {
			var value = eval("element."+paramName);
			if (typeof(value) == "undefined") return null;
			else if (value == "false") return false;
			else if (value == "true") return true;
			else return value;
		}
	}

	if (!__Page.GetParameter("HelpletsEnabled")) __Page.HelpletReadyState = "serverDisabled";
	else if (__Page.CookieHandler.Read("HelpletsEnabled") != null) __Page.HelpletReadyState = "clientDisabled";
	else if (__Page.GetParameter("HelpletFile")) {
		__trace("should load helplet file: "+element.HelpletFile);
		var script = document.createElement("script");
		// TODO: support non-IE browsers
		script.onreadystatechange = function() {
			if (this.readyState == "loaded" || this.readyState == "complete") {
				__trace(element.HelpletFile+" was loaded");
				__Page.HelpletReadyState = "ready";
			}
		}
		script.src = element.HelpletFile;
		document.body.appendChild(script);
		script = null;
	} else {
		__Page.HelpletReadyState = "missing";
	}

	if (__Page.GetParameter("CustomAgentVersion")) {
		__trace("should load custom agent file: "+element.AgentDirectory+"/CustomAgent_"+element.CustomAgentVersion+".js");
		var script = document.createElement("script");
		script.onreadystatechange = function() {
			if (this.readyState == "loaded" || this.readyState == "complete") {
				__trace(element.AgentDirectory+"/CustomAgent_"+element.CustomAgentVersion+".js was loaded");
				__Page.CustomAgentReadyState = "ready";
				__Page.fireEvent("customready");
			}
		}
		script.onload = function() {
			__trace(element.AgentDirectory+"/CustomAgent_"+element.CustomAgentVersion+".js was loaded");
			__Page.CustomAgentReadyState = "ready";
			__Page.fireEvent("customready");
		}
		script.src = element.AgentDirectory+"/CustomAgent_"+element.CustomAgentVersion+".js";
		document.body.appendChild(script);
		script = null;
	}

	function __Event(et, u, X, Y) {
	    this.ent = this.getEnt();
		this.u = this.getU(u);
		this.t = this.getT();
		this.X = this.getX(X);
		this.Y = this.getY(Y);
		this.et = this.getET(et);
		this.events = new Array();
	}
	__Event.prototype.ToString = function(debug) {
		var rs = "";
		var ers = new Array();
		if (!debug) {
			rs = "<event><![CDATA[";
			for (var i in this) {
				if (typeof(this[i]) == "object") {
					if (i == "et") rs += i+"="+this[i].id+"&";
					else if (i == "events") {
						for (var x=0;x<this[i].length;x++) {
							ers[ers.length] = this[i][x].ToString();
						}
					}
				} else if (typeof(this[i]) != "function") {
					rs += i+"="+((i == "u") ? this[i].replace(/[\&|\?]$/,"").replace(/\&/g, "^^") : this[i])+"&";
				}
			}
//			rs += "timestamp=2008-09-09 15:45:45.000&";
			rs += "]]></event>";
			rs += ers.join("");
		} else {
			rs = "<table border='0'><tr><td style='font-family:Tahoma;font-size:11px;' colspan='2'><b>Log object:</b></td></tr>";
			for (var i in this) {
				if (typeof(this[i]) == "object") {
					if (typeof(this[i].ToString) == "function") {
						rs += "<tr><td style='font-family:Tahoma;font-size:11px;'>"+i+":"+this[i].ToString()+"</td></tr>";
					} else {
						if (this[i] != null && this[i].length) {
							for (var x=0;x<this[i].length;x++) {
								ers[ers.length] = this[i][x].ToString(true);
							}
						} else {
							var rs1 = "";
							for (var y in this[i]) if (typeof(this[i][y]) != "function") rs1 += "<tr><td></td><td style='font-family:Tahoma;font-size:11px;'>"+y+":"+this[i][y]+"</td></tr>";
							rs += "<tr><td style='font-family:Tahoma;font-size:11px;'>"+i+":</td></tr>"+rs1;
						}
					}
				} else if (typeof(this[i]) != "function") rs += "<tr><td style='font-family:Tahoma;font-size:11px;'>"+i+":"+this[i]+"</td></tr>";
			}
			rs += "</table>";
			rs += ers.join("");
		}
		return rs;
	}
	__Event.prototype.addEvent = function(event) {
		this.events[this.events.length] = event;
	}
	__Event.prototype.getEnt = function(ent) { return (typeof(ent) != "undefined") ? ent : ""; }
	__Event.prototype.getU = function(u) { return (typeof(u) != "undefined") ? u : element.document.location.href; }
	__Event.prototype.getT = function(t) { return (typeof(t) != "undefined") ? t : ""; }
	__Event.prototype.getX = function(x) { return (typeof(x) != "undefined") ? x : ""; }
	__Event.prototype.getY = function(y) { return (typeof(y) != "undefined") ? y : ""; }
	__Event.prototype.getET = function(et) { return (typeof(et) != "undefined") ? et : __eEvents.Visit; }

	var __EventHandler = {
		New: function(type) { return new __Event(type); },
		NewVisit: function() {
			var shouldReturnEvent = true;
			var event = new __Event(__Page.eventType);
			event.t = __Page.entityType;

			if (event.et == __eEvents.Search) {
				var lastSearchTerm = __Page.CookieHandler.Read("LastSearchTerm");
				var lastSearchedArea = __Page.CookieHandler.Read("LastSearchedArea");
				var firstResultPosition = 0;
				var currentKeyword = (typeof(__Page.Search.eKeyword) != "undefined") ? __Page.Search.eKeyword : __Page.Search.Keyword;
				if (lastSearchTerm == currentKeyword && lastSearchedArea == __Page.Search.EntityId) {
					var lastSearchResultsCount = parseInt(__Page.CookieHandler.Read("LastSearchResultsCount"), 10);

					if (__Page.agent == "MOSS2007Agent") {
						// MOSS 2007 shows number of total results even if you have paging (not like 2003 that says: more than X retults...
						var currentSearchResultsCount = parseInt(__Page.Search.FirstResultOnPage, 10);
					} else {
						var currentSearchResultsCount = parseInt(__Page.Search.NumberOfTotalResults, 10);
					}

					if (__Page.agent == "MOSS2007Agent" || __Page.agent == "SP2003Agent") {
						if (lastSearchResultsCount < currentSearchResultsCount) {
							event.AlterEvent = __Page.CookieHandler.Read("LastSearchEventId");
							firstResultPosition = lastSearchResultsCount;
							__Status.print('more results for the same query. (id #'+__Page.CookieHandler.Read("LastSearchEventId")+')');
						} else {
							shouldReturnEvent = false;
						}
					} else shouldReturnEvent = false;
				}

				__Page.CookieHandler.Save("LastSearchTerm", currentKeyword, parseInt(element.SearchPeriod, 10)/1440);
				__Page.CookieHandler.Save("LastSearchedArea", __Page.Search.EntityId, parseInt(element.SearchPeriod, 10)/1440);

				event.storeEventAsSearch = (event.AlterEvent) ? false : true;

				event.X = __Page.Search.Keyword;
				event.Y = __Page.Search.NumberOfTotalResults;
				event.Z = __Page.Search.FirstResultOnPage;
				event.AreaId = __Page.Search.EntityId;
				//alert(__Page.CookieHandler.Read("LastVisitURL"));
				
				event.u = __Page.CookieHandler.Read("LastVisitURL");
				event.RI = __Page.CookieHandler.Read("LastEventId");

				// add view event on search page
				var viewevent = new __Event();
				viewevent.u = document.location.href;
				event.addEvent(viewevent);

				//alert(__Page.CookieHandler.Read("LastSearchEventId"));
				if (__Page.Search.Results.length > 0) {
					for (var i=0;i<__Page.Search.Results.length;i++) {
					    //disable search result events
					    //if (__Page.shouldIncludeEvent("SearchResultItem")) {
						//	var sriEvent = new __Event(__Page.Search.Results[i].__type, __Page.Search.Results[i].href, eval(__Page.Search.FirstResultOnPage+i));
						//	event.addEvent(sriEvent);
						//}
						if (__Page.shouldIncludeEvent("SearchResultClick")) {
							__Page.Search.Results[i].resultPosition = __Page.Search.FirstResultOnPage+i;
							//__Page.Search.Results[i].innerHTML = eval(__Page.Search.FirstResultOnPage+i)+". "+__Page.Search.Results[i].innerHTML;
							__Page.Search.Results[i].onclick = function() {
								//__Page.sendEvent(new __Event(__eEvents.SearchResultClick, this.href, this.resultPosition, __EventHandler.lastEventId), false, true);
								var lastSearchEvent = (__Page.CookieHandler.Read("LastSearchEventId") == null) ? __EventHandler.lastEventId : __Page.CookieHandler.Read("LastSearchEventId");
								__Page.setReferrer("Search Result", this.href);
								var event = new __Event(__eEvents.SearchResultClick, this.href, this.resultPosition, lastSearchEvent);
								//event.timestamp = dateToString(new Date());
								event.timestamp = dateToString(getServerDate());
								// 28/12/2008: handle multiple clicks on external links (currently stores the last one only)
				                var eventsInQueue = __Page.CookieHandler.Read("LastEventsToSend");
				                if (eventsInQueue == null) eventsInQueue = "";
				                eventsInQueue += escape(event.ToString());
		                                //alert(unescape(eventsInQueue));
				                __Page.CookieHandler.Save("LastEventsToSend", eventsInQueue, 1000);
								__Page.CookieHandler.Save("LastEventToSend", escape(event.ToString()), 1000);
								//__Page.sendEvent(new __Event(__eEvents.SearchResultClick, this.href, this.resultPosition, lastSearchEvent), false, true);
							}
							//__Page.Search.Results[i].innerText = eval(__Page.Search.FirstResultOnPage+i)+": "+__Page.Search.Results[i].innerText;
						}
					}
				}
			} else if (event.et == __eEvents.Visit) {
                event.referrer = __Referrer.GetReferrer();
			} else {
				// if you want to store last url only for real pages, uncomment the following line and remove the first line after the if 
				//__Page.CookieHandler.Save("LastVisitURL", document.location.href);
			}
			// comment the following line if you want to keep last visit only on real pages and not on searches
			lastVisitUrl = document.location.href.replace(/\&/g, "^^");
			lastVisitUrl = lastVisitUrl.replace(/=/g, "!!");
			__Page.CookieHandler.Save("LastVisitURL", lastVisitUrl);
			__trace("NewVisit return "+((shouldReturnEvent) ? event.ToString() : null));
			return (shouldReturnEvent) ? event : null;
		},
		SetLastEventId: function(id, storeEventAsSearch) {
			this.lastEventId = id;
			__Page.CookieHandler.Save("LastEventId", id);
			if (storeEventAsSearch) {
				//alert('saving new lastsearcheventid:'+id);
				__Page.CookieHandler.Save("LastSearchEventId", id);
			}
		}
	}

	function initAgentBase() {
		if (element.BrowserType == "ie" && element.document.readyState != "interactive" && element.document.readyState != "complete") {
			element.document.onreadystatechange = function() {
				if (element.document.readyState == "interactive") {
					__Page.init();
				}
			}
		} else __Page.init();
	}

	var __Status = {
		output: new Array(),
		currentMessage: "",
		print: function(value, type) {
			if (type == "statusbar") {
				this.currentMessage = value;
				if (__Page.CookieHandler.Read("debugMessages") != null) window.status = this.currentMessage;
			}
			var line = {o:value, t:type};
			this.output[this.output.length] = line;
			if (__Page.console) {
				try {
					__Page.console.writeLine(line);
				} catch (e) {
				}
			}
		},
		clear: function() { }
	}
	var __Ajax = {
		getTransport: function() {
			var transports = new Array(function() { return new ActiveXObject("Msxml2.XMLHTTP"); },
							function() { return new ActiveXObject("Microsoft.XMLHTTP"); });

			if (element.BrowserType == "ie") {
				for (var i=0;i<transports.length;i++) {
					try {
						var x = transports[i]();
						return x;
					} catch (e) {
					}
				}
			} else return new XMLHttpRequest();
			return false;
		}
	}
	__Ajax.transport = __Ajax.getTransport();

	__Ajax.transports = new Array();

	__Ajax.createTransport = function() {
		for (var i=this.transports.length-1;i>=0;i--) {
			if (this.transports[i].readyState == 4) return this.transports[i];
		}
		var position = this.transports.length;
		this.transports[position] = __Ajax.getTransport();
		return this.transports[position];
	}


	__Ajax.Request = function AjaxRequest(method, url, parameters, async, catchError, callback, ignoreResponse) {
		__Status.clear();

		url = url;
		this.callback = callback;
		this.catchError = catchError;
		if (element.TunnelPath.match(/^http/) && element.TunnelPath.replace(/http[s]*\:\/\/([^\/]*).*$/, "$1") != element.document.location.href.replace(/http[s]*\:\/\/([^\/]*).*$/, "$1")) {
			__trace("use XSS to send event to "+url);
			// todo: make sure tunnel.aspx returns in js format in case format=JS
			url += "?format=JS&"+parameters;
			__Status.print(url, "link");
			var script = document.createElement("script");
			document.body.appendChild(script);
			script.onload = function() {
				__trace(url+" was loaded");
				__Ajax.HandleResponseAsJS();
			}
			script.onreadystatechange = function() { 
				if (script.readyState == "loaded" || script.readyState == "complete") {
					__trace(url+" was loaded");
					__Ajax.HandleResponseAsJS();
				}  
			}
			script.src = url;
			return;
		}
		__trace("use AJAX to send event to "+url);
		if (method == "GET") url += "?"+parameters;
		var transport = this.createTransport();
		transport.open(method, url, async);

		if (async && !ignoreResponse) transport.onreadystatechange = function() { __Ajax.HandleOnreadystatechange(transport); };
		if (method == "POST") transport.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

		__Status.print("<textarea style='width:100%; height:100px;'>"+parameters+"</textarea>");
		__Status.print(url+((method == "POST") ? "?"+parameters : ""), "link");
		__trace("AJAX call: "+url+((method == "POS") ? "?"+parameters : ""));
		transport.send((method == "POST") ? parameters : "");

		if (!async && !ignoreResponse) this.HandleResponse(transport);
	}
	__Ajax.HandleOnreadystatechange = function(transport) {
		if (transport.readyState == 4) {
			__Ajax.HandleResponse(transport);
		}
	}
	__Ajax.HandleResponseAsJS = function() {
		if (typeof(element.document.currentResponse) != "undefined") {
			__trace("response from XSS call: "+element.document.currentResponse.statusText);
			var status = {errorCode:0, reason:""};
			var transport = element.document.currentResponse;
			if (transport.statusId != 0) {
				status.errorCode = "-1";
				status.reason = transport.statusId+" - "+transport.statusText;
			} else {
				__Status.print("<textarea style='width:100%; height:100px;'><status>"+transport.statusId+"</status><statusText>"+transport.statusText+"</statusText><eventId>"+transport.eventId+"</eventId></textarea>");
			}
			if (this.catchError) __Status.print(status.reason, "status");
			status.eventId = transport.eventId;
			if (typeof(this.callback) != "undefined") this.callback(status);
		} else __trace("response from XSS in undefined");
	}
	
	__Ajax.HandleResponse = function(transport) {
		var status = {errorCode:0, reason:""};
		if (transport.status != 200) {
			__trace("response from AJAX is "+transport.status+" - "+transport.statusText);
			status.errorCode = "-1";
			status.reason = transport.status+" - "+transport.statusText;
		} else {
			__trace("response from AJAX is "+transport.ResponseText);
			__Status.print("<textarea style='width:100%; height:100px;'>"+transport.ResponseText+"</textarea>");
			if (transport.ResponseXml) {
				if (transport.ResponseXml.parseError && transport.ResponseXml.parseError.errorCode != 0) {
					status.errorCode = transport.ResponseXml.parseError.errorCode;
					status.reason = transport.ResponseXml.parseError.reason;
				} else {
					var statusNode = transport.ResponseXml.selectSingleNode(".//status");
					if (statusNode) {
						status.errorCode = statusNode.getAttribute("id");
						status.reason = statusNode.text;
					}
				}
			}
		}
		status.ResponseText = transport.ResponseText;
		if (transport.ResponseXml && transport.ResponseXml.xml != "") status.ResponseXml = transport.ResponseXml;

		if (this.catchError) __Status.print(status.reason, "status");
		this.callback(status);
	}
	__Ajax.Dispose = function() {
	}
	
	function dateToString(v) {
	    function fixYear(value) {
	        return value < 1000 ? 1000+value : value;
	    }
	    function lpad(value) {
	        value = value+"";
	        return value.length == 1 ? "0"+value : value;
	    }
	    return v.getFullYear()+"-"+lpad(eval(v.getMonth()+1))+"-"+lpad(v.getDate())+" "+lpad(v.getHours())+":"+lpad(v.getMinutes())+":"+lpad(v.getSeconds())+".000";
	}
} catch (e) {
	var __Page = {readyState:"error", errorDescription:e.message};
}

element.document.__Page = __Page;
if (element.document.__Callback) element.document.__Callback(this);


var extensions = {};
extensions[".aspx"] = true;
extensions[".null"] = true;

function handleLinks(e) {
    try {
	    var obj = (typeof(event) != "undefined") ? event.srcElement : e.originalTarget;
	    while (obj.tagName.toLowerCase() != "body" && obj.tagName.toLowerCase() != "a") obj = obj.parentElement;
	    if (obj.tagName.toLowerCase() == "a") {
	        try {
		        var href = obj.href;
    //		    if (href.match(/^javascript/)) return;
		        var extension = href.match(/\.[a-z]+/i);

		        var domain = href.match(/(?:http[s]?\:\/\/)[^\/]*/);
		        var mydomain = document.location.href.match(/(?:http[s]?\:\/\/)[^\/]*/);
		        
		        if (domain != null && typeof(domain[0]) != "undefined") domain = domain[0];
		        if (mydomain != null && typeof(mydomain[0]) != "undefined") mydomain = mydomain[0];
                
		        if (extension != null && typeof(extension[0]) != "undefined") extension = extension[0];
                if (extension == null) extension = ".null";

                var port = domain.match(/.*\:([0-9]*)$/) ? domain.replace(/^.*\:([0-9]*)$/, ":$1") : "";
                var isExtension = (element.HandleFileExtension == true && !extensions[extension] && domain.replace(/http[s]?:\/\//, "") == document.domain+port)
		        if (    
		                (isExtension)
		                || (domain.replace(/http[s]?:\/\//, "") != mydomain.replace(/http[s]?:\/\//, "") && !href.match(/^javascript/)) 
		                && href != ""
		            ) {
		            if(isExtension)
		            {
		                var eventToSend = __Page.GetEvent("Visit", href, "", "", __EventHandler.lastEventId);
		            }
		            else
		            {
		                var eventToSend = __Page.GetEvent("External", href, "", "", __EventHandler.lastEventId);
			        }
			        //eventToSend.timestamp = dateToString(new Date());
			        eventToSend.timestamp = dateToString(getServerDate());

					// 28/12/2008: handle multiple clicks on external links (currently stores the last one only)
				    var eventsInQueue = __Page.CookieHandler.Read("LastEventsToSend");
				    if (eventsInQueue == null) eventsInQueue = "";
				    eventsInQueue += escape(eventToSend.ToString());

				    __Page.CookieHandler.Save("LastEventsToSend", eventsInQueue, 1000);
				    //__Page.CookieHandler.Save("LastEventToSend", eventToSend.ToString(), 1000);
				    //__Page.SendEvent("Visit", href, "", "");
		        }
            } catch (e) {
            }
	    }
    } catch (e) {
        if (typeof(console) != "undefined") console.info(e.message);
    }
}

__Page.getURL = function(url, referrer, newWindow) {
	SendExternalEvent({innerText:"Flash > "+referrer, freeURL:true});
	if (newWindow) window.open(url, "newWindow");
	else top.location.href = url;
}

function SendExternalEvent(obj) {
	try {
		__trace("SendExternalEvent");
		var sessionId = __Page.getClientSession();
		var url = element.EventCollectorPath;
		var u = obj.innerText;
		// entity type is -2 for custom events
		var event = "<event><![CDATA[ent=&u="+u+"&t=-2&X=&Y=&et=0&]]></event>";
		var parameters = "browserType="+navigator.userAgent.toLowerCase()+"&sessionId="+sessionId+"&u="+url+"&events=<events>"+escape(event)+"</events>&un="+GetUsername();
		__Ajax.Request("POST", element.AgentDirectory + "/tunnel.aspx", parameters, true, false, false, true);
	} catch (e) {
		alert(e.description);
	}
	return true;
}


__Page.attachEvent("onload", function() {
	if (document.addEventListener)
		__Page.document.body.addEventListener("mousedown", handleLinks, false);
	else
		__Page.document.body.attachEvent("onmousedown", handleLinks);
});

function getServerDate()
{
    var d1 = new Date();
    if(element.ClientServerTimeDifference < 0)
    {
        return (new Date(d1.getTime() - element.ClientServerTimeDifference));
    }
    else
    {
        return (new Date(d1.getTime() + element.ClientServerTimeDifference));
    }
}

var __Referrer = {url:document.location.href, ignoreref:false, loaded:false, medium:"direct", source:"", term:"", campaign:"", content:"", sites:[], adsites:[], refs:[], site:document.referrer};
__Referrer.campaignkeys = {"campaign":"utm_campaign", "source":"utm_source", "medium":"utm_medium", "content":"utm_content", "term":"utm_term"};

__Referrer.GetReferrer = function() {
    if (!this.loaded) this.init();
	return this;
}

__Referrer.ToString = function() {
    if (!this.loaded) this.init();
    return escape(this.medium)+"|"+escape(this.source)+"|"+escape(this.term)+"|"+escape(this.campaign)+"|"+escape(this.content);
}
__Referrer.init = function() {
    var url = document.location.href;
	
    var se = this._getAdsense();
    if (se != null) {
        se.medium = "adsense";
        this.source = se.source;
        this.term = se.term;
        this.medium = se.medium;
    } else {
        se = this._getSearch();
        if (se != null) {
	        se.medium = (url.match(/[&\?]gclid=/)) ? "cpc" : "organic";
	        this.source = se.source;
	        this.term = se.term;
	        this.medium = se.medium;
        }
    }
    var c = this._getCampaign();
    if (c != null) {
        this.source = c.source || this.source;
        this.term = c.term || this.term;
        this.medium = c.medium || "";
        this.content = c.content || this.content;
        this.campaign = c.campaign || this.campaign;
        return;
    } else {
		var r = this._getReferrer();
		if (r != null) {
			this.source = this.source || r.source;
			this.medium = (this.medium == "direct") ? ((url.match(/[&\?]gclid=/)) ? "adsense" : r.medium) : this.medium;
			this.term = this.term || r.term;
		} else this.ignoreref = true;
	}
}   

__Referrer._getParam = function(name) {
    var re = new RegExp("[&\\\?]"+name+"=([^&]*)", "i");
    var m = document.location.search.match(re);
    return (m != null) ? m[1] : "";
}
__Referrer._getReferrer = function() {
    var r = document.referrer;
    if (r == "") return null;
    
	if (document.__refstoignore) __Referrer._addIgnoredRefs(document.__refstoignore);
	if (this._extractReferrer(this.site)) return null;

    var o = {};
	
    var m = r.match(/http[s]?\:\/\/([^\/]*)([^\?]*)/i);
    if (m != null) {
        o.source = m[1] || "";
        o.term = r.replace(/\?.*$/, ""); //m[2] || "";
        o.medium = "referral";
    }
    return (document.domain.match(o.source)) ? null : o;
}
    
__Referrer.stripcampaignparams = function(u) {
	u = u.replace(/\^\^/g, "&");
    for (var i in this.campaignkeys) {
		var paramname = "";
		if (document.__campaignkeys && document.__campaignkeys.hasOwnProperty(i) && document.__campaignkeys[i] != "") paramname = document.__campaignkeys[i];
		else if (this.campaignkeys.hasOwnProperty(i)) paramname = this.campaignkeys[i];
		var re = new RegExp(paramname+"=[^\&]*[\&]?", "i");
		u = u.replace(re, "");
	}
	if (u.match(/[\&|\?]$/)) u = u.replace(/[\&|\?]$/,"");
	return u.replace(/\&/g, "^^");
}

__Referrer._getCampaign = function() {
    var o = {};
    for (var i in this.campaignkeys) {
		var paramname = "";
		if (document.__campaignkeys && document.__campaignkeys.hasOwnProperty(i) && document.__campaignkeys[i] != "") paramname = document.__campaignkeys[i];
		else if (this.campaignkeys.hasOwnProperty(i)) paramname = this.campaignkeys[i];
		o[i] = this._getParam(paramname);
		var re = new RegExp(paramname+"=[^\&]*[\&]?", "i");
		this.url = this.url.replace(re, "");
	}

	if (this.url.match(/[\&|\?]$/)) this.url = this.url.replace(/[\&|\?]$/,"");
	
    return (o.medium != "" || o.source != "" || o.campaign != "" || o.term != "" || o.content != "") ? o : null;
}

__Referrer._extractReferrer = function(url) {
    if (!url) return null;
    for (var m, i = this.refs.length-1; i >= 0; --i)  {
	    if (m = this.refs[i].exec(url)) return true;
    }
}

__Referrer._extractSearch = function(url) {
    if (!url) return null;
    for (var m, i = this.sites.length-1; i >= 0; --i)  {
	    if (m = this.sites[i].exec(url)) {
		    return {source:m[1], term:decodeURIComponent(m[2])};
	    }
    }
}
__Referrer._extractAdsense = function(url) {
    if (!url) return null;
    for (var m, i = this.adsites.length-1; i >= 0; --i)  {
	    if (m = this.adsites[i].exec(url)) {
		    return {source:m[1], term:decodeURIComponent(m[2])};
	    }
    }
}

__Referrer._getSearch = function() {
    return this._extractSearch(this.site);
}
__Referrer._getAdsense = function() {
    return this._extractAdsense(this.site);
}

__Referrer._addOrganic = function(domain, keyword, prepend) {
    if (prepend) this.sites.splice(0, 0, new RegExp("^http[s]?:\/\/[^\/]*?\\b("+domain+")(?:[^\/]*)\/.+?[\?&]"+keyword+"=([^&#]*)", "i"));
    else this.sites.push(new RegExp("^http[s]?:\/\/[^\/]*?\\b("+domain+")(?:[^\/]*)\/.+?[\?&]"+keyword+"=([^&#]*)", "i"));
}
__Referrer._addAdsense = function(domain, keyword, prepend) {
    if (prepend) this.adsites.splice(0, 0, new RegExp("^http[s]?:\/\/[^\/]*?\\b("+domain+")(?:[^\/]*)\/.+?[\?&]"+keyword+"=([^&#]*)", "i"));
    else this.adsites.push(new RegExp("^http[s]?:\/\/[^\/]*?\\b("+domain+")(?:[^\/]*)\/.+?[\?&]"+keyword+"=([^&#]*)", "i"));
}
__Referrer._addIgnoredRef = function(domain, prepend) {
    if (prepend) this.refs.splice(0, 0, new RegExp("^http[s]?:\/\/[^\/]*?\\b("+domain+")", "i"));
    else this.refs.push(new RegExp("^http[s]?:\/\/[^\/]*?\\b("+domain+")", "i"));
}
__Referrer._addOrganics = function(list) {
    var searches = list.split(",");
    for (var i=0;i<searches.length;i++) this._addOrganic(searches[i].split(":")[0], searches[i].split(":")[1]);
}
__Referrer._addAdsenses = function(list) {
    var adsenses = list.split(",");
    for (var i=0;i<adsenses.length;i++) this._addAdsense(adsenses[i].split(":")[0], adsenses[i].split(":")[1]);
}

__Referrer._addIgnoredRefs = function(list) {
    var refs = list.split(",");
    for (var i=0;i<refs.length;i++) this._addIgnoredRef(refs[i].replace(/http[s]?/,""));
}

__Referrer._addAdsenses("googleads:q");
__Referrer._addOrganics("daum:q,eniro:search_word,naver:query,images.google:q,google:q,yahoo:p,msn:q,bing:q,aol:query,aol:encquery,lycos:query,ask:q,altavista:q,netscape:query,cnn:query,about:terms,mamma:query,alltheweb:q,voila:rdata,virgilio:qs,live:q,baidu:wd,alice:qs,yandex:text,najdi:q,aol:q,mama:query,seznam:q,search:q,wp:szukaj,onet:qt,szukacz:q,yam:k,pchome:q,kvasir:q,sesam:q,ozu:q,terra:query,mynet:q,ekolay:q,rambler:words");
