﻿    <%@ Page language="C#" %>
    <%
	    Response.ContentType = "text/x-component";
	    bool realTime;
	    try
	    {
            realTime = CardioLog.API.ProductLicense.ProductFeatures.IsValidRealTimeReports;
	    }
	    catch
	    {
	        realTime = false;
	    }
    %>
    <% 
        string cardioLogUIVersion;
        try
	    {
            cardioLogUIVersion = CardioLog.API.CardioLogUIVersion.UIVersion;
        }
        catch
        {
            cardioLogUIVersion = "2007";
        } 
    %>
    <html xmlns:CARDIOLOG>
    <head>

		    <%if(cardioLogUIVersion=="2007"){ %>
		    <LINK rel="stylesheet" type="text/css" href="/CardioLog/styles/general.css"></LINK>
            <% } if(cardioLogUIVersion=="2010"){ %>        
		    <LINK rel="stylesheet" type="text/css" href="/CardioLog/styles/2010_general.css"></LINK>
            <% } %>
            
	    <meta http-equiv="content-type" content="text/html; charset=utf-8">
	    <PUBLIC:COMPONENT tagName=PAGEPREFERENCES>
		    <PUBLIC:DEFAULTS viewLinkContent/>
		    <PUBLIC:ATTACH event="oncontentready" onevent="init()"/>
    		
		    <PUBLIC:METHOD name="hide"></PUBLIC:METHOD>
		    <PUBLIC:METHOD name="show"></PUBLIC:METHOD>
		    <PUBLIC:METHOD name="setAvailableTemplates"></PUBLIC:METHOD>
		    <PUBLIC:METHOD name="selectTempateById"></PUBLIC:METHOD>
		    <PUBLIC:METHOD name="selectTempateByName"></PUBLIC:METHOD>
    		
		    <PUBLIC:METHOD name="isClosed"></PUBLIC:METHOD>
    		
		    <PUBLIC:METHOD name="getPreferences"></PUBLIC:METHOD>
    		
		    <PUBLIC:METHOD name="drawPreferences"></PUBLIC:METHOD>
	    </PUBLIC:COMPONENT>
	    <script language="JScript">
		    var cardioLogUIVersion = "<%= cardioLogUIVersion%>";
		    element.params = new Array();

		    function init() {
			    defaults.viewLink = document;
			    defaults.viewInheritStyle = false;

			    document.body.ondblclick = function() { event.cancelBubble = true; };
			    document.body.onselectstart = function() { event.cancelBubble = true; event.returnValue = true; return true; };
						    if (element.mode == "advanced") {
    //				document.all["defaultTemplateSep"].style.display = "";
    //				document.all["defaultTemplate"].style.display = "";
			    }
			    stylesPath = (element.stylesPath) ? element.stylesPath : "";
			    imagesPath = (element.imagesPath) ? element.imagesPath : "";

			    if (!element.document.isReport) {
				    var option = document.createElement("<option value=''>");
				    option.innerText = element.document.EntityName;
				    document.all["sourceSelect"].insertBefore(option, document.all["sourceSelect"].children[0]);
				    option = null;
			    }
		    }

		    function getCommonAuth() {
			    return "";
		    }
		    function getCommonSource() {
			    return "";
		    }
		    function getCommonTimeframe() {
			    return "36000000000";
		    }
		    function setCommonTimeInterval(value) {
		        var timeframe = document.getElementById("timeFrame").options[document.getElementById("timeFrame").selectedIndex];   
		        timeframe.timeInterval = value;
		    }
		    function getMultipleSelection() {
			    return true;
		    }

            function hasStatic(values) {
                for (var i=0;i<values.length;i++) {
                    if (values[i] == "static") return true;
                }
                return false;
            }

            function isStatic(values) {
                for (var i=0;i<values.length;i++) {
                    if (values[i] != "static") return false;
                }
                return true;
            }
		    function findCommonValue(values, defaultValue, catchError, ignoreStaticValues) {
			    var different = false;
			    lastValue = defaultValue;
			    for (var i=0;i<values.length;i++) {
			        if (values[i] != "static" || !ignoreStaticValues) {
			            lastValue = values[i];
			            break;
			        }
			    }
    //			var lastValue = (values.length > 0 && values[0] != "") ? values[0] : defaultValue;

			    for (var i=0;i<values.length;i++) {
			        if (values[i] == "static" && ignoreStaticValues) continue;
    			    
				    if (values[i] == "") values[i] = defaultValue;

				    if (values[i] != lastValue) {
					    if (!catchError) throw {description:"no common", value:lastValue};
					    else break;
				    } else lastValue = values[i];
			    }
    			
			    if (lastValue == "") return defaultValue;
			    else return lastValue;
		    }
		    function addOption(text, select) {
			    if (select.options[0].value == -99) select.options[0].innerText = text;
			    else {
				    var option = document.createElement("option");
				    option.value = -99;
				    option.innerText = text;
				    select.insertBefore(option, select.options[0]);
				    option = null;
			    }
			    select.selectedIndex = 0;
		    }
		    function getPreferences() {
			    var timeframe = document.getElementById("timeFrame").options[document.getElementById("timeFrame").selectedIndex];
			    var source = document.getElementById("sourceSelect").options[document.getElementById("sourceSelect").selectedIndex];
			    var sourceUrl = document.getElementById("entityUrl").value;
			    var users = document.getElementById("groupSelect").options[document.getElementById("groupSelect").selectedIndex];
    			
			    var props = new Array();
			    if (timeframe.value != -99) {
				    props.push({name:"timeframe", value:timeframe.value});
                    
                    // set default time interval
                    props.push({name:"timeinterval", value:Math.abs(timeframe.value)});
                    
				    if (timeframe.value == 0) {
					    var timeframeStart = timeframe.timeFrameStart;
					    var timeframeEnd = timeframe.timeFrameEnd;
					    var timeInterval = timeframe.timeInterval;
					    
					    // set default time interval
					    if (timeInterval == 0)
					        timeInterval = "864000000000"; //day
					        
					    props.push({name:"timeframe_start", value:timeframeStart});
					    props.push({name:"timeframe_end", value:timeframeEnd});
					    props.push({name:"timeframe_title", value:timeframe.innerText});
					    props.push({name:"timeinterval", value:timeInterval});
				    } else {
					    props.push({name:"timeframe_start", value:"", action:"delete"});
					    props.push({name:"timeframe_end", value:"", action:"delete"});
					    props.push({name:"timeframe_title", value:"", action:"delete"});
				    }
			    }
    			
			    if (source.value != -99) {
				    props.push({name:"entityId", value:source.value}); 
				    props.push({name:"entityName", value:source.innerText});
				    props.push({name:"entityTree", value:document.all["entityTree"].value});
			    }
			    if (sourceUrl != "") {
				    props.push({name:"entityUrl", value:sourceUrl});
			    }

			    if (users.value != -99) {
				    var groupSelectValue = users.value;
				    var groupSelectText = users.innerText;
				    var groupIdsArr = groupSelectValue.split(',');
				    var groupNamesArr = groupSelectText.split(',');
				    var userIds = "";
				    var groupIds = "";
				    var userNames = "";
				    var groupNames = "";
				    for(var i=0;i<groupIdsArr.length;i++) {
					    if ( groupIdsArr[i] != "" ) {
						    var objectIdsArr = groupIdsArr[i].split(';');
						    if ( objectIdsArr[1] == "user" ) {
							    userIds += objectIdsArr[0] + ",";
							    userNames += groupNamesArr[i] + ",";
						    } else {
							    groupIds += objectIdsArr[0] + ",";
							    groupNames += groupNamesArr[i] + ",";
						    }
					    }
				    }
				    userIds = userIds.replace(/,$/, "");
				    groupIds = groupIds.replace(/,$/, "");
				    userNames = userNames.replace(/,$/, "");
				    groupNames = groupNames.replace(/,$/, "");
    				
				    if ( userIds != "" ) {
					    props.push({name:"aduser", value:userIds});
					    props.push({name:"adusername", value:userNames});
				    } else {
					    props.push({name:"aduser", value:""});
					    props.push({name:"adusername", value:""});
				    }
				    if ( groupIds != "" ) { 
					    props.push({name:"adgroup", value:groupIds});
					    props.push({name:"adgroupname", value:groupNames});
				    } else {
					    props.push({name:"adgroup", value:""});
					    props.push({name:"adgroupname", value:""});
				    }
			    }
		        return props;
		    }
		    function setPreferences() {

		        var props = getPreferences();
			    element.document.scheduler.setProperties(props);
			    drawPreferences();
		    }
		    function isClosed() {
			    return (document.body.style.visibility == "hidden");
		    }
    		
		    function drawPreferences() {
    		    
			    /*********************************/
			    /* set timeframe                 */
			    /*********************************/
			    var timeframes = element.document.scheduler.getPropertyByName("timeframe");
			    var tmStartArr = element.document.scheduler.getPropertyByName("timeframe_start");
			    var tmEndArr = element.document.scheduler.getPropertyByName("timeframe_end");
			    var tmTitleArr = element.document.scheduler.getPropertyByName("timeframe_title");

                var timeintervals = element.document.scheduler.getPropertyByName("timeinterval");

                var staticTimeframe = false; //isStatic(timeframes);
                document.all["chooseDateRangeTR"].style.display = (staticTimeframe) ? "none" : "";

			    var rs = "";
			    for (var i=0;i<timeframes.length;i++) rs += timeframes[i]+"\n";
			    var timeframe, timeframestart, timeframeend, timeframetitle, timeinterval;
			    try {
				    timeframe = findCommonValue(timeframes, getCommonTimeframe(), false, true);
				    document.all["dateRangeComment"].style.display = "none";
			    } catch (e) {
				    timeframe = -99;
				    document.all["dateRangeComment"].style.display = "";
			    }
			    if (timeframe == "static") {
                    //document.getElementById("chooseDateRangeTR").style.display = "none";                
                } else {
                    //document.getElementById("chooseDateRangeTR").style.display = "";                
                    if (timeframe == 0) {
				        timeframestart = findCommonValue(tmStartArr, "20070101000000", true);
				        timeframeend = findCommonValue(tmEndArr, "20070102000000", true);
				        timeframetitle = findCommonValue(tmTitleArr, "01/01/2007 - 02/01/2007", true);
				        
				        timeinterval = findCommonValue(timeintervals, "864000000000", true);
				        
				        initPeriods(false, addCustomizedOption(timeinterval, timeframestart, timeframeend, timeframetitle));
			        } else {
			            initPeriods(timeframe);
				        if (timeframe == -99) addOption("<%=CardioLog.API.Localization.getText("$Please choose date range$")%>", document.getElementById("timeFrame"));
			        }
			        if (hasStatic(timeframes)) {
			            document.all["dateRangetitle"].innerHTML = "<img src='/cardiolog/images/info.gif' style='' align='absmiddle' /> Date Range:";
			            document.all["dateRangetitle"].title = "<%=CardioLog.API.Localization.getText("$applies to some controls$")%>";
			        } else {
			            document.all["dateRangetitle"].innerHTML = "<%=CardioLog.API.Localization.getText("$Date Range$")%>:";
			            document.all["dateRangetitle"].title = "";
			        }
                }
                
			    /*********************************/
			    /* set source                    */
			    /*********************************/
			    var entityIds = element.document.scheduler.getPropertyByName("entityid");
                var entityTrees = element.document.scheduler.getPropertyByName("entitytree");
			    var entityNames = element.document.scheduler.getPropertyByName("entityname");
			    var entityurls = element.document.scheduler.getPropertyByName("entityurl", "static");
    			
			    var entityUrl, entityId, entityTree, entityName;
    			
			    var staticEntityUrl = isStatic(entityurls);
			    var staticEntityId = isStatic(entityIds);
    			
			    document.all["chooseEntityUrl"].style.display = (staticEntityUrl) ? "none" : "";
			    document.all["chooseEntityId"].style.display = (staticEntityId) ? "none" : "";
    			
			    try {
				    entityUrl = findCommonValue(entityurls, "static", false, true);
				    if (entityUrl == "static") {
					    //document.all["chooseEntityUrl"].style.display = "none";
				    } else {
					    //document.all["chooseEntityUrl"].style.display = "";
					    document.all["entityUrl"].value = entityUrl;
				    }
			    } catch (e) {
				    //document.all["chooseEntityUrl"].style.display = "";
				    var notstatic = new Array();
				    for (var i=0;i<entityurls.length;i++) {
					    if (entityurls[i] != "" && entityurls[i] != "static") {
						    notstatic.push(entityurls[i]);
						    document.all["entityUrl"].value = entityurls[i];
					    }
				    }
				    try {
					    entityUrl = findCommonValue(notstatic, "", false);
					    document.all["entityUrlComment"].style.display = "none";
				    } catch (e) {
					    document.all["entityUrl"].value = "";
					    document.all["entityUrlComment"].style.display = "";
				    }
			    }
			    try {
				    entityName = findCommonValue(entityNames, "", true);
				 	entityTree = findCommonValue(entityTrees, "0", true);

                    // remove "0:" for comparison purposes
                    var tempEntityIds = entityIds.slice();
                    for (var i=0;i<tempEntityIds.length;i++) {
                        tempEntityIds[i] = tempEntityIds[i].replace(/0:/g,"");
                    }

                    entityId = findCommonValue(tempEntityIds, "", false);
				    if (entityId == "static") {
					    document.all["chooseEntityId"].style.display = "none";
				    } else {
					    document.all["chooseEntityId"].style.display = "";
					    document.all["entityIdComment"].style.display = "none";
					    addSource(entityId, entityName);
					    document.all["entityId"].innerText = entityId;
					    document.all["entityTree"].value = entityTree;
				    }
			    } catch (e) {
				    var notstatic = new Array();
				    var notstaticNames = new Array();
    				
				    for (var i=0;i<entityIds.length;i++) {
					    if (entityIds[i] != "static") {
						    notstatic.push(entityIds[i]);
						    notstaticNames.push(entityNames[i]);
					    }
				    }
				    document.all["chooseEntityId"].style.display = "";
				    try {
					    entityId = findCommonValue(notstatic, "", false);
					    entityName = findCommonValue(notstaticNames, "", false);
					    document.all["entityIdComment"].style.display = "none";
				    } catch (e) {
					    document.all["entityIdComment"].style.display = "";
					    entityId = -99;
				    }
				    if (entityId != -99) {
					    if (entityName == "") entityName = element.document.EntityName;//"<%=CardioLog.API.Localization.getText("$Current Page$")%>";
					    addSource(entityId, entityName);
					    document.all["entityId"].innerText = entityId;
					    document.all["entityTree"].value = entityTree;
				    } else {
					    addOption("<%=CardioLog.API.Localization.getText("$Please choose source$")%>", document.getElementById("sourceSelect"));
				    }
			    }

			    if (entityId != "static" && entityUrl != "static") {
				    document.all["entityIdTitle"].innerHTML = "<img src='/cardiolog/images/info.gif' style='' align='absmiddle' /> <%=CardioLog.API.Localization.getText("$Source$")%>:";
				    document.all["entityUrlTitle"].innerHTML = "<img src='/cardiolog/images/info.gif' style='' align='absmiddle' /> <%=CardioLog.API.Localization.getText("$Source$")%> <%=CardioLog.API.Localization.getText("$Url$")%>:";
				    document.all["entityIdTitle"].title = "<%=CardioLog.API.Localization.getText("$applies to source$")%>";
				    document.all["entityUrlTitle"].title = "<%=CardioLog.API.Localization.getText("$applies only to URL$")%>";
			    } else {
				    document.all["entityIdTitle"].innerHTML = "<%=CardioLog.API.Localization.getText("$Source$")%>:";
				    document.all["entityUrlTitle"].innerHTML = "<%=CardioLog.API.Localization.getText("$Source$")%> <%=CardioLog.API.Localization.getText("$Url$")%>:";
				    document.all["entityIdTitle"].title = "";
				    document.all["entityUrlTitle"].title = "";
			    }
    			
			    /*********************************/
			    /* set users and groups          */
			    /*********************************/
			    var adgroups, adgroupnames, adusers, adusernames;
			    var adgroup, adgroupname, aduser, adusername;

			    adgroups = element.document.scheduler.getPropertyByName("adgroup");
			    adgroupnames = element.document.scheduler.getPropertyByName("adgroupname");
			    adusers = element.document.scheduler.getPropertyByName("aduser");
			    adusernames = element.document.scheduler.getPropertyByName("adusername");

			    var showComment = false;
			    var showADSection = true; //!isStatic(adgroups);

			    try {
				    adgroup = findCommonValue(adgroups, "", false, true);
			    } catch (e) {
				    adgroup = e.value;
				    showComment = true;
			    }
			    try {
				    adgroupname = findCommonValue(adgroupnames, "", false);
			    } catch (e) {
				    adgroupname = e.value;
				    showComment = true;
			    }
			    try {
				    aduser = findCommonValue(adusers, "", false);
			    } catch (e) {
				    aduser = e.value;
				    showComment = true;
			    }
			    try {
				    adusername = findCommonValue(adusernames, "", false);
			    } catch (e) {
				    adusername = e.value;
				    showComment = true;
			    }

			    if (!showADSection) {
			        document.getElementById("chooseActiveDirectoryTR").style.display = "none";
			    } else {
			        document.getElementById("chooseActiveDirectoryTR").style.display = "";
			        addGroup(drawUserInfoIds(aduser, adgroup), drawUserInfoNames(adusername, adgroupname));

			        if (showComment) {
				        addOption("Please choose users and groups", document.getElementById("groupSelect"));
				        document.all["authComment"].style.display = "";
			        } else {
				        document.all["authComment"].style.display = "none";
			        }
    			    
			        if (hasStatic(adgroups)) {
			            document.all["chooseADTitle"].innerHTML = "<img src='/cardiolog/images/info.gif' style='' align='absmiddle' /> Users and Groups:";
			            document.all["chooseADTitle"].title = "<%=CardioLog.API.Localization.getText("$applies to Active Directory$")%>";
			        } else {
			            document.all["chooseADTitle"].innerHTML = "<%=CardioLog.API.Localization.getText("$Users and Groups$")%>:";
			            document.all["chooseADTitle"].title = ""
			        }
                }
                
			    /*********************************/
			    /* set categories                */
			    /*********************************/

			    // fix for weird bug in IE6
    //			document.body.children[0].style.display = "none";
    //			document.body.style.visibility = "hidden";
		    }
		    var lastSelectedTimeFrame = false;
		    var lastSelectedGroup = false;
		    var lastSelectedSource = false;
    		
		    function changeAuthentication(select) {
			    if (select.options[select.selectedIndex].value == "customize") chooseAuthentication();
			    else lastSelectedGroup = select.selectedIndex;
		    }

		    function chooseAuthentication() {
			    var selectedGroup = (lastSelectedGroup) ? document.all["groupSelect"].options[lastSelectedGroup] : false;
			    var myJSONObject  = 
			    { "popupArguments":
			    [		
			     {href:"ADChooser.aspx", selectedGroup:selectedGroup, title:"<%=CardioLog.API.Localization.getText("$Select Users and Groups$")%>", type:null, callback:chooseAuthenticationPost, self:element}	
			     ]
			     };	
			    if (cardioLogUIVersion == "2010") 
			        parent.PopupManager.ShowPopup("/CardioLog/2010/CLPage/adchooser.aspx",394,500,myJSONObject) ;
			    else
			        var md = window.showModalDialog("cont.aspx", {href:"ADChooser.aspx", selectedGroup:selectedGroup, title:"<%=CardioLog.API.Localization.getText("$Select Users and Groups$")%>", type:null, callback:chooseAuthenticationPost, self:element}, "dialogWidth:300px; dialogHeight:420px; status:no; help:no;");
			    if (document.all["groupSelect"].selectedIndex == document.all["groupSelect"].options.length-1) {
				    document.all["groupSelect"].selectedIndex = lastSelectedGroup;
			    }
		    }

		    function chooseAuthenticationPost(groups, ids) {
			    addGroup(ids, groups);
		    }

		    function addGroup(value, text) {
			    for (var i=0;i<document.all["groupSelect"].options.length;i++) {
				    if (document.all["groupSelect"].options[i].value == value) {
					    document.all["groupSelect"].selectedIndex = i;
					    lastSelectedGroup = i;
					    return;
				    }
			    }
			    var option = document.createElement("option");
			    option.value = value;
			    option.innerText = text;
			    document.all["groupSelect"].insertBefore(option, document.all["groupSelect"].children[document.all["groupSelect"].children.length-1]);
			    document.all["groupSelect"].selectedIndex = document.all["groupSelect"].children.length-2;
			    option = null;
			    lastSelectedGroup = document.all["groupSelect"].selectedIndex;
		    }
    		
		    function changeSource(select) {
			    if (select.options[select.selectedIndex].value == "customize") chooseObject();
			    else lastSelectedSource = select.selectedIndex;
		    }
    		
		    function addSource(value, text) {
			    if (value.length != 0 && !value.match(/^(true)?[0-9]*:/)) value = "0:"+value;
			    for (var i=0;i<document.all["sourceSelect"].options.length;i++) {
				    if (document.all["sourceSelect"].options[i].value == value) {
					    document.all["sourceSelect"].selectedIndex = i;
					    lastSelectedSource = i;
					    return;
				    }
			    }
			    var option = document.createElement("option");
			    option.value = value;
			    option.innerText = text;
			    document.all["sourceSelect"].insertBefore(option, document.all["sourceSelect"].children[document.all["sourceSelect"].children.length-1]);
			    document.all["sourceSelect"].selectedIndex = document.all["sourceSelect"].children.length-2;
			    option = null;
			    lastSelectedSource = document.all["sourceSelect"].selectedIndex;
		    }
    		
		    function getSource() {
			    return document.all["sourceSelect"].options[document.all["sourceSelect"].selectedIndex];
		    }
    		
		    function chooseObjectPost(entry, treeType, multiple) {
			    if (multiple) {
				    var entityId = "";
				    var entityTree = "";
				    var entityName = "";
				    var entityValue = "";
    				
				    for (var i=0;i<entry.length;i++) {
				    //alert(entry[i].url);
					    entityId += entry[i].id+",";
					    entityTree += entry[i].treeType+",";
					    entityName += ((entry[i].discard) ? "!" : "")+entry[i].name+", ";
					    entityValue += ((entry[i].discard) ? "true:" : "")+entry[i].treeType+":"+entry[i].id+",";
				    }
				    entityId = entityId.replace(/,$/, "");
				    entityValue = entityValue.replace(/,$/, "");
				    entityTree = entityTree.replace(/,$/, "");
				    entityName = entityName.replace(/, $/, "");

				    addSource(entityValue, entityName);
				    document.all["entityId"].value = entityId;
				    document.all["entityTree"].value = entityTree;
			    } else {
				    if (entry) {
					    addSource(entry.id, entry.name);
					    document.all["entityId"].value = entry.id;
					    document.all["entityTree"].value = treeType;
				    } else {
					    addSource("", Constants.currentPage);
					    document.all["entityId"].value = "";
					    document.all["entityTree"].value = "";
				    }
			    }
		    }	

		    function chooseObject() {
			    var selectedSource = (lastSelectedSource !== false) ? document.all["sourceSelect"].options[lastSelectedSource] : false;
			    var treeType = "1";
			     var myJSONObject  = 
			    { "popupArguments":
			    [			{"treeType":0, "selectedSource":selectedSource, "multiple":getMultipleSelection(), "callback":chooseObjectPost, "self":element}		  ]
			     };			
			      if (element.document.isReport)  
	  			    {
	  			    if (cardioLogUIVersion == "2010") 
	  			        parent.PopupManager.ShowPopup("/CardioLog/2010/Tree/treesChooserCont.aspx",515,400,myJSONObject);
	  			    else
 				    var md = window.showModalDialog("../Tree/treesChooserCont.aspx", {treeType:0, selectedSource:selectedSource, multiple:getMultipleSelection(), callback:chooseObjectPost, self:element} , "dialogWidth:300px; dialogHeight:400px; status:no; help:no;");
	  			    }
    			    
                    else
                   {
	  			    if (cardioLogUIVersion == "2010") 
                        parent.PopupManager.ShowPopup("/CardioLog/2010/Tree/treesChooserCont.aspx",515,400,myJSONObject);
                    else 
				    var md = window.showModalDialog("../Tree/treesChooserCont.aspx", {treeType:treeType, selectedSource:selectedSource, multiple:getMultipleSelection(), callback:chooseObjectPost, self:element}, "dialogWidth:300px; dialogHeight:400px; status:no; help:no;");
                   } 
			    if (document.all["sourceSelect"].selectedIndex == document.all["sourceSelect"].options.length-1) {
				    document.all["sourceSelect"].selectedIndex = lastSelectedSource;
			    }
		    }

		    function initPeriods(defaultValue, extraOption) {
			    var realTime = "<%=realTime%>";
		        if(realTime == "True")
			    {
			        var periods = new Array({value:600000000, text:'<%=CardioLog.API.Localization.getText("$Hour$")%>'},
									    {value:36000000000, text:'<%=CardioLog.API.Localization.getText("$Day$")%>'},
									    {value:864000000000, text:'<%=CardioLog.API.Localization.getText("$Week$")%>'},
									    {value:6048000000000, text:'<%=CardioLog.API.Localization.getText("$Month$")%>'},
									    {value:25920000000000, text:"<%=CardioLog.API.Localization.getText("$Quarter$")%>"},
									    {value:77760000000000, text:"<%=CardioLog.API.Localization.getText("$Year$")%>"});
		        }
			    else
			    {
			        var periods = new Array({value:36000000000, text:'<%=CardioLog.API.Localization.getText("$Day$")%>'},
									    {value:864000000000, text:'<%=CardioLog.API.Localization.getText("$Week$")%>'},
									    {value:6048000000000, text:'<%=CardioLog.API.Localization.getText("$Month$")%>'},
									    {value:25920000000000, text:"<%=CardioLog.API.Localization.getText("$Quarter$")%>"},
									    {value:77760000000000, text:"<%=CardioLog.API.Localization.getText("$Year$")%>"});
			    }
			    function createOption(value, text) {
				    var option = document.createElement("option");
				    option.innerText = text;
				    option.value = value;
				    return option;
			    }
			    var option;
			    var children = document.all["timeFrame"].children;
			    for (var i=children.length-1;i>=0;i--) children[i].removeNode(true);
			    for (var i=0;i<periods.length;i++) {
			        // Remove This Day
			        if (periods[i].value != "36000000000" || realTime == "True") {
				        option = createOption(periods[i].value, "<%=CardioLog.API.Localization.getText("$This$")%> "+periods[i].text);
				        if (defaultValue == periods[i].value) {
					        option.selected = true;
					        lastSelectedTimeFrame = i*2;
				        }
				        document.all["timeFrame"].appendChild(option);
				        option = null;
                    }
				    option = createOption(-periods[i].value, "<%=CardioLog.API.Localization.getText("$Last$")%> "+periods[i].text);
				    if (defaultValue < 0 && Math.abs(defaultValue) == periods[i].value) {
					    option.selected = true;
					    lastSelectedTimeFrame = i*2+1;
				    }
				    document.all["timeFrame"].appendChild(option);
				    option = null;
			    }
    			
			    if (extraOption) {
				    document.all["timeFrame"].appendChild(extraOption);
    //				document.all["timeFrame"].selectedIndex = document.all["timeFrame"].options.length-1;
				    extraOption.selected = true;
				    lastSelectedTimeFrame = document.all["timeFrame"].options.length-1;
			    }
    			
			    option = createOption("customize", "<%=CardioLog.API.Localization.getText("$Customize$")%>...");
			    document.all["timeFrame"].appendChild(option);
			    option = null;
		    }

		    function changeUnitType(obj) {
			    if (obj.options[obj.selectedIndex].value == "customize") {
				    chooseDateRange();
				    return;
			    } else {
				    lastSelectedTimeFrame = obj.selectedIndex;
				    if (obj.options[obj.selectedIndex].value == "0") {
					    setCommonTimeInterval(obj.options[obj.selectedIndex].timeInterval);
					    return;
				    }
			    }
		    }
    		
		    function chooseDateRange() {
			    function cancelCallback() {
				    document.all["timeFrame"].selectedIndex = lastSelectedTimeFrame;
			    } 
			    if (cardioLogUIVersion == "2010") {
			        var myJSONObject  = 
		                { "popupArguments":
		                [	{source:"clpage/index", title:"<%=CardioLog.API.Localization.getText("$Choose Date Range$")%>", self:self, option:(lastSelectedTimeFrame >= 0) ? document.all["timeFrame"].options[lastSelectedTimeFrame] : false, currentTimeInterval:864000000000, hideInterval:false, callback:setDateRange, cancelCallback:cancelCallback}  ]
		                 };
		                 
                    parent.PopupManager.ShowPopup("/CardioLog/2010/CLReport/wwcalendar.aspx", 394, 574, myJSONObject);
                } else
			        window.showModelessDialog("cont.aspx", {title:"<%=CardioLog.API.Localization.getText("$Choose Date Range$")%>", href:"chooseDateRange.aspx", self:self, option:(lastSelectedTimeFrame >= 0) ? document.all["timeFrame"].options[lastSelectedTimeFrame] : false, currentTimeInterval:864000000000, hideInterval:false, callback:setDateRange, cancelCallback:cancelCallback}, "dialogHeight:460px; dialogWidth:530px; status:no; help:no;");
		    }

		    function setDateRange(timeInterval, start, end, title, dynamic) {
		        if (!end) end = new Date();
			    end = new Date(end.setHours(23, 59, 59));
			    var option;
			    if (!dynamic)
				    option = addCustomizedOption(timeInterval, flatDate(start, 0, 0, 0), flatDate(end, 0, 0, 0), title);
			    else
				    option = addCustomizedOption(timeInterval, start, "today", title);

			    var existingOption = findOption(document.all["timeFrame"], option);
			    if (existingOption) existingOption.selected = true;
			    else {
				    document.all["timeFrame"].insertBefore(option, document.all["timeFrame"].options[document.all["timeFrame"].options.length-1]);
				    document.all["timeFrame"].selectedIndex = document.all["timeFrame"].options.length-2;
			    }
			    lastSelectedTimeFrame = document.all["timeFrame"].selectedIndex;
			    option = null;
			    setCommonTimeInterval(timeInterval);
		    }

		    function addCustomizedOption(timeInterval, start, end, title) {
		        var option = document.createElement("option");
			    option.value = "0";
			    option.timeFrameStart = start;
			    option.timeFrameEnd = end;
			    option.timeInterval = timeInterval;
			    option.innerText = title;
			    return option;
		    }

		    function findOption(select, option) {
			    for (var i=0;i<select.options.length;i++) {
				    if (select.options[i].value == option.value && select.options[i].innerText == option.innerText) return select.options[i];
			    }
			    return false;
		    }

		    function drawUserInfoIds(aduser, adgroup){
			    var groupIdsArr = "";
			    var userIdsArr = "";
			    var groupIds = "";
			    var userIds = "";
    			
			    if (adgroup) {
				    groupIdsArr = adgroup.split(',');
				    for(var i=0;i<groupIdsArr.length;i++) {
					    groupIds += groupIdsArr[i] + ";group,";
				    }
				    groupIds = groupIds.replace(/,$/, "");
			    }
			    if (aduser) {
				    userIdsArr = aduser.split(',');
				    for(var i=0;i<userIdsArr.length;i++) {
					    userIds += userIdsArr[i] + ";user,";
				    }
				    userIds = userIds.replace(/,$/, "");
			    }
    		
			    if (userIds != "" && groupIds != "")
				    return(groupIds+","+userIds);
			    else if (userIds == "" && groupIds != "")
				    return(groupIds);
			    else if (userIds != "" && groupIds == "")
				    return(userIds);
			    else
				    return "";
		    }
    		
		    function drawUserInfoNames(adusername, adgroupname){
			    if (adusername && adgroupname && adusername != "" && adgroupname != "")
				    return(adgroupname+","+adusername);
			    else if (adgroupname && adgroupname != "" && (adusername == "" || !(adusername)))
				    return(adgroupname);
			    else if (adusername != "" && (adgroupname == "" || !(adgroupname)))
				    return(adusername);
			    else
				    return "";
		    }
    		
		    function flatDate(value, hours, minutes, seconds) {
			    function lpad(value) {
				    value = value+"";
				    if (value.length == 1) return "0"+value;
				    else return value;
			    }
			    return value.getYear()+lpad(value.getMonth()+1)+lpad(value.getDate())+lpad(hours)+lpad(minutes)+lpad(seconds);
		    }
    		
		    function show() {
			    document.body.style.visibility = "visible";
			    drawPreferences();
			    return;
			    var selects = document.getElementsByTagName("select");
			    for (var i=0;i<selects.length;i++) selects[i].style.visibility = "visible";
		    }
		    function hide() {
			    document.body.style.visibility = "hidden";
			    return;
			    var selects = document.getElementsByTagName("select");
			    for (var i=0;i<selects.length;i++) selects[i].style.visibility = "hidden";
		    }
		    function selectTempateById(templateId) {
			    for (var i=0;i<document.all["templateSelect"].children.length;i++) {
				    if (document.all["templateSelect"].children[i].value == templateId) {
					    document.all["templateSelect"].selectedIndex = i;
					    break;
				    }
			    }
		    }
		    function selectTempateByName(templateName) {
			    for (var i=0;i<document.all["templateSelect"].children.length;i++) {
				    if (document.all["templateSelect"].children[i].innerText == templateName) {
					    document.all["templateSelect"].selectedIndex = i;
					    break;
				    }
			    }
		    }
    		
		    function setAvailableTemplates(templates, managed, templateId) {
			    for (var i=document.all["templateSelect"].children.length-1;i>=0;i--) document.all["templateSelect"].children[i].removeNode(true);

			    for (var i=0;i<templates.length;i++) {
				    var option = createOption(templates[i].id, templates[i].title, (templates[i].id == templateId) ? true : false);
				    document.all["templateSelect"].appendChild(option);
				    option = null;
			    }
			    if (managed) document.all["templateSelect"].appendChild(createOption("", "<%=CardioLog.API.Localization.getText("$Customized View$")%>"));
    			
			    if (document.all["templateSelect"].options.length == 0) {
				    var trs = document.getElementById("preferencesBody").children;
				    for (var i=trs.length-1;i>=0;i--) trs[i].removeNode(true);
				    var tr = document.getElementById("preferencesBody").appendChild(document.createElement("tr"));
				    var td = tr.appendChild(document.createElement("td"));
				    td.className = "regText";
				    td.colSpan = 3;
				    td.innerText = "<%=CardioLog.API.Localization.getText("$No Templates$")%> ("+element.document.EntityType+")";
				    td = null;
				    tr = null;
			    }
		    }

		    function createOption(value, text, selected) {
			    var option = document.createElement("option");
			    option.value = value;
			    option.innerText = text;
			    option.selected = selected;
			    return option;
		    }
    		
		    function handleCustomized() {
			    if (document.all["templateSelect"].options[document.all["templateSelect"].selectedIndex].value == "") document.all["templateName"].style.display = "";
			    else document.all["templateName"].style.display = "none";
		    }

		    function save() {
			    if (document.all["templateName"].style.display == "" && document.all["templateName"].value.replace(/ /g, "") == "") {
				    document.all["templateName"].className = "inputTextError";
				    return;
			    }
			    document.all["templateName"].className = "inputText";
			    element.document.setDefaultTemplate(document.all["templateSelect"].options[document.all["templateSelect"].selectedIndex].value, document.all["templateName"].value);
		    }
    		
		    function toggleAdvancedPreferences() {
			    document.getElementById("defaultTemplateSpan").style.display = (document.getElementById("defaultTemplateSpan").style.display == "none") ? "" : "none";
		    }
			// Support copy & paste
            function handleKey() {
				if (event.keyCode == 86 && event.ctrlKey) { // ctrl + v
					event.returnValue = false;
					event.keyCode = 0;
                    paste();
					return false;
				}
			}
            function paste() {
                if (window.clipboardData.getData('Text') != "") {
                    document.getElementById("entityUrl").value = window.clipboardData.getData('Text');
                }
            }
	    </script>
    </head>
    <body style="border:0px; padding:5px;">
	    <table border="0" cellpadding="3" cellspacing="0" width="100%">
	   
	        <% if (cardioLogUIVersion == "2007")
            { %>
		        <tbody id="preferencesBody">
			    <tr id="chooseDateRangeTR" style="display:none;"><td align="left" class="regTextBig" nowrap="true" id="dateRangetitle"><%=CardioLog.API.Localization.getText("$Date Range$")%>:</td>
				    <td><nobr><select class="inputSelectBig" id="timeFrame" onchange="changeUnitType(this);" style="width:300px;"><option value=""><%=CardioLog.API.Localization.getText("$Last Day$")%></option></select></nobr></td>
				    <td width="100%"><span id="dateRangeComment" style="display:none;" class="regTextBig" title="<%=CardioLog.API.Localization.getText("$common date range$")%>">&nbsp; &nbsp;<img src="/cardiolog/images/warning.gif" align="absmiddle" /> <%=CardioLog.API.Localization.getText("$Different date range$")%> (?)</span></nobr></td></tr>			
			    <tr id="chooseEntityId" style="display:none;">
				    <td align="left" class="regTextBig" nowrap="true" id="entityIdTitle"></td>
				    <td><nobr><select class="inputSelectBig" id="sourceSelect" style="width:300px;" onchange="changeSource(this)">
								    <option value="customize"><%=CardioLog.API.Localization.getText("$Customize$")%>...</option>
							    </select></nobr></td>
				    <td width="100%"><span id="entityIdComment" style="display:none;" class="regTextBig" title="<%=CardioLog.API.Localization.getText("$common source$")%>">&nbsp; &nbsp;<img src="/cardiolog/images/warning.gif" align="absmiddle" /> <%=CardioLog.API.Localization.getText("$Different source$")%> (?)</span>
				    </td></tr>
			    <tr id="chooseEntityUrl"><td align="left" class="regTextBig" nowrap="true" id="entityUrlTitle"></td>
				    <td><nobr><input type="text" id="entityUrl" style="width:300px" class="largeInputText"></nobr>
							    <input type="hidden" id="entityId"><input type="hidden" id="entityTree"></td>
				    <td width="100%"><span id="entityUrlComment" style="display:none;" class="regTextBig" title="<%=CardioLog.API.Localization.getText("$common source url$")%>">&nbsp; &nbsp;<img src="/cardiolog/images/warning.gif" align="absmiddle" /> <%=CardioLog.API.Localization.getText("$Different source$")%> (?)</span></td></tr>
			    <tr id="chooseActiveDirectoryTR" style="display:none;"><td align="left" class="regTextBig" nowrap="true" id="chooseADTitle"><%=CardioLog.API.Localization.getText("$Users and Groups$")%>:</td>
				    <td><nobr><select class="inputSelectBig" id="groupSelect" style="width:300px;" onchange="changeAuthentication(this)">
							    <option value=''><%=CardioLog.API.Localization.getText("$All$")%></option>
							    <option value='customize'><%=CardioLog.API.Localization.getText("$Customize$")%>...</option>
						    </select></nobr></td>
				    <td width="100%"><span id="authComment" style="display:none;" class="regTextBig" title="<%=CardioLog.API.Localization.getText("$common users and groups$")%>">&nbsp; &nbsp;<img src="/cardiolog/images/warning.gif" align="absmiddle" /> <%=CardioLog.API.Localization.getText("$Different users and groups$")%> (?)</span>
				    </td></tr>
			    <tr><td colspan="2" align="right"><input type="button" class="inputButtonBig" value="<%=CardioLog.API.Localization.getText("$Set$")%>" onclick="setPreferences()"></td></tr>
			    <tr id="defaultTemplateSep" style="display:none;"><td><br /></td></tr>
			    <tr id="defaultTemplate" style="display:none;"><td colspan="3">
					    <nobr><a class="boxHelpRegLink" onclick="toggleAdvancedPreferences()"><%=CardioLog.API.Localization.getText("$Set default template for this page$")%></a> <span id="defaultTemplateSpan" style="display:none;"><select class="inputSelectBig" id="templateSelect" onchange="handleCustomized()" style="width:200px;"></select> <input type="text" id="templateName" class="inputText" style="display:none;" onselectstart="event.cancelBubble=true;"> <input type="button" class="inputButtonBig" value="<%=CardioLog.API.Localization.getText("$Set$")%>" onclick="save()"></span></nobr></td>
			    </tr>
    			
			    <!--tr id="restoreMyManagedTr" style="display:none;"><td colspan="3" class="regText"><input type="checkbox" id="restoreMyManaged"><label for="restoreMyManaged">Restore my customized page</label></td></tr-->
		    </tbody>		
    		
	        <% } if (cardioLogUIVersion == "2010")
            { %>
		        <tbody id="preferencesBody">
			    <tr id="chooseDateRangeTR" style="display:none;"><td align="left" class="regTextBig" nowrap="true" id="dateRangetitle"><%=CardioLog.API.Localization.getText("$Date Range$")%>:</td>
				    <td><nobr><select class="inputSelectBig" id="timeFrame" onchange="changeUnitType(this);" style="width:300px;"><option value=""><%=CardioLog.API.Localization.getText("$Last Day$")%></option></select></nobr></td>
				    <td width="100%"><span id="dateRangeComment" style="display:none;" class="regTextSmallB" title="<%=CardioLog.API.Localization.getText("$common date range$")%>"> <%=CardioLog.API.Localization.getText("$Different date range$")%> (?)</span></nobr></td></tr>			
			    <tr id="chooseEntityId" style="display:none;">
				    <td align="left" class="regTextBig" nowrap="true" id="entityIdTitle"></td>
				    <td><nobr><select class="inputSelectBig" id="sourceSelect" style="width:300px;" onchange="changeSource(this)">
								    <option value="customize"><%=CardioLog.API.Localization.getText("$Customize$")%>...</option>
							    </select></nobr></td>
				    <td width="100%"><span id="entityIdComment" style="display:none;" class="regTextSmallB" title="<%=CardioLog.API.Localization.getText("$common source$")%>"> <%=CardioLog.API.Localization.getText("$Different source$")%> (?)</span></td>
                </tr>
			    <tr id="chooseEntityUrl"><td align="left" class="regTextBig" nowrap="true" id="entityUrlTitle"></td>
				    <td><nobr><input type="text" id="entityUrl" style="width:300px" class="largeInputText" onkeydown="handleKey()" oncontextmenu="return false;"></nobr>
							    <input type="hidden" id="entityId"><input type="hidden" id="entityTree"></td>
				    <td width="100%"><span id="entityUrlComment" style="display:none;" class="regTextSmallB" title="<%=CardioLog.API.Localization.getText("$common source url$")%>"> <%=CardioLog.API.Localization.getText("$Different source$")%> (?)</span></td>
                </tr>
                <tr id="chooseActiveDirectoryTR" style="display:none;"><td align="left" class="regTextBig" nowrap="true" id="chooseADTitle"><%=CardioLog.API.Localization.getText("$Users and Groups$")%>:</td>
				    <td><nobr><select class="inputSelectBig" id="groupSelect" style="width:300px;" onchange="changeAuthentication(this)">
							    <option value=''><%=CardioLog.API.Localization.getText("$All$")%></option>
							    <option value='customize'><%=CardioLog.API.Localization.getText("$Customize$")%>...</option>
						    </select></nobr></td>
                    <td width="100%"><span id="authComment" style="display:none;" class="regTextSmallB" title="<%=CardioLog.API.Localization.getText("$common users and groups$")%>"> <%=CardioLog.API.Localization.getText("$Different users and groups$")%> (?)</span>
                        <span onclick="setPreferences()" align="left" style="width:100px; padding-left:10px; vertical-align:bottom;">
		                    <table cellpadding=0 cellspacing=0 border=0>
		                        <tr>		
        				            <td><img src="/CardioLog/images/2010/EmptyGreyBtnLeft.gif" /></td><td class="2010_GreyButton" align="center" style="width:100px"><%=CardioLog.API.Localization.getText("$Go$")%></td><td><img src="/CardioLog/images/2010/EmptyGreyBtnRight.gif" style="margin-right:10px"/></td>
			                    </tr>
			                </table>
			            </span> 
                    </td>
                    
			    </tr>
			    <tr id="defaultTemplateSep" style="display:none;"><td><br /></td></tr>
			    <tr id="defaultTemplate" style="display:none;"><td colspan="3">
					    <nobr><a class="boxHelpRegLink" onclick="toggleAdvancedPreferences()"><%=CardioLog.API.Localization.getText("$Set default template for this page$")%></a> <span id="defaultTemplateSpan" style="display:none;"><select class="inputSelectBig" id="templateSelect" onchange="handleCustomized()" style="width:200px;"></select> <input type="text" id="templateName" class="inputText" style="display:none;" onselectstart="event.cancelBubble=true;"> <input type="button" class="inputButtonBig" value="<%=CardioLog.API.Localization.getText("$Go$")%>" onclick="save()"></span></nobr></td>
			    </tr>
    			
			    <!--tr id="restoreMyManagedTr" style="display:none;"><td colspan="3" class="regText"><input type="checkbox" id="restoreMyManaged"><label for="restoreMyManaged">Restore my customized page</label></td></tr-->
		    </tbody>			
    		
		    <% } %>
	    </table>
    </body>
    </html>